      parameter (nx=21,ny=59)

      character*72 fname*80,record
      
      real txy(nx,ny), transxy(ny,nx),z(20)

      common/ scales /xscale,yscale,xmn,ymn,nps

      lun = 50
      fname = 'cohplot'
c----------------------------------------------------------------------
10    write (6,*) 'enter file name (default=plot):'
      read (5,1000) record
      if (record.ne.' ') fname = record
      open (lun,file=fname,err=20,status='old')
      goto 30 
20    write (6,*) 'could not open file ',fname,', try again'  
      goto 10 
c---------------------------------------------------------------------
30    read (lun,*) nz
      read (lun,*) dx,dy,xmin,ymin
      read (lun,*) ix,iy

      write (*,*) ' enter iz:'
      read (*,*) iz

      if (ix.ne.nx .or. iy.gt.ny ) then 
         write (6,*) 'wrong dimensioning'
         goto 99 
      end if 

      call psopen (fname,ier)

      ymax = ymin + (iy-1) * dy
      xmax = xmin + (ix-1) * dx 

      call psssc2 (xmin,xmax,ymin,ymax)

      do i = 1, nx 
         do j = 1, ny
            read (lun,*) (z(k), k = 1, nz)
            if (iz.eq.3) z(iz) = z(iz) / 2.302585093
            if (iz.eq.9) then
               if (z(iz).le.0.) then
                  z(iz) = -10
               else 
                  z(iz) = log10(z(iz))
               end if 
            end if 
            txy(i,j) = z(iz)
         end do
      end do
         
      tmin = 1.d10
      tmax = -1.d10
                                      
      do i = 1, ix
         do j = 1, iy 
            if (txy(i,j).lt.tmin) tmin = txy(i,j)
            if (txy(i,j).gt.tmax) tmax = txy(i,j)
         end do 
       end do 
c                                      set up contour intervals
       write (6,*) 'tmax, tmin',tmax,tmin
       write (6,*) 'enter cmin,cmax,dcon'
       read (5,*) cmin,cmax,dcon
       if (dcon.ne.0.) then 
          ncon = (cmax-cmin)/dcon + 1.1
       else 
          dcon = (tmax-tmin)/10.
          ncon = 11
       end if 
c                                      make contour diagram
       call psstrn (0.2,0.2,100.,100.,0.)

       call pscontor (txy,dx,dy,xmin,ymin,nx,ny,
     *      cmin,ncon,dcon,transxy)

99    call psclos 

      close (lun)

1000  format (a72)
1020  format (a250)
1050  format (bn,i80)
      end 

      subroutine pscontor (z,dx,dy,xmin,ymin,nx,ny,
     *                     cmin,ncon,dcon,trans)
c----------------------------------------------------------------
c suncontour is a program to contour a potential in x-y space.   
c----------------------------------------------------------------
c input:
c
c card 2 : nx, ny - number of x and y values, respectively.
c card 3 : dx, dy - spacing of points in x and y directions, 
c          respectively.
c rest   : z(i,j),i=1,nx,j=1,ny - value of the potential at each x-y 
c          point.
c----------------------------------------------------------------

      implicit real (a-g,o-z), integer (h-n)

      parameter (nseg=20000,npts=10000,npcs=400,mcon=50)

      character*(*)  kontor*50
c    
      real z(nx,ny),
     *     cont(mcon),trans(ny,nx),clinex(npts),
     *     cliney(npts),linex(1000),liney(1000),cline(2,npts),
     *     segs(4,nseg)

      integer ipieces(2,npcs),npiece(mcon),ifirst(mcon),
     *        next(nseg),ilast(mcon)
c----------------------------------------------------------------            
      xmax = xmin + (nx-1)*dx
      ymax = ymin + (ny-1)*dy
      xlen = xmax - xmin
      ylen = ymax - ymin

      write (*,*) 'axes y=1'
      read (*,*) iax
       
c                                  x:y ratio of viewport set by
c                                  suncompick is 1.00:0.69, set 
c                                  window accoringly.
      dyl = ylen / 7.0
      ytl = ylen + 2.0 * dyl
      dxl = xlen / 7.0
      xtl = xlen + 2.0 * dxl 
c                                  contor interval
      write (kontor,1000) dcon 
1000  format ('contor interval=',g9.3)
      call pssctr (7,0.9,0.9,0.0)
      call pstext (xmin+2.*dx,ymin+2.*dy,kontor,0)

      do i = 1, ncon
           cont(i) = cmin + (i-1) * dcon
      end do 

      do i = 1, nx 
         do j = 1, ny 
              trans(j,i)= z(i,j)
         end do
      end do 

      call psrect (xmin,xmax,ymin,ymax,1.,2,0)

      if (iax.eq.1) call psylabels (xmin,xmax,ymin,ymax)

      if (iax.eq.1) call psxlabels (xmin,xmax,ymin,ymax)

      call contra (trans,ny,nx,xmin,xmax,ymin,
     *             ymax,ncon,cont,clinex,cliney,cline,segs,
     *             npts,nseg,npcs,ipieces,npiece,
     *             ifirst,next,ilast)

      ipiece = 1
        ithick = 0
         do k = 1, ncon

c            if (ithick.eq.2) then
               ithick = 1
               rline = 1.
c            else
c               ithick = 2
c               rline = 1
c            end if

            np = npiece(k)
            if (np.gt.0) then 
               do i = 1, np
                  istart = ipieces(1,ipiece)
                  ipts = ipieces(2,ipiece)
                  do j = 1, ipts
                     linex(j) = clinex(istart+j-1)
                     liney(j) = cliney(istart+j-1)
                  end do

                  call psbspl (linex,liney,ipts,rline,ithick,0)

                  ipiece = ipiece + 1
                end do 
             end if
          end do 
      end        
c---------------------------------------------------------------
      subroutine psylabels (xmin,xmax,ymin,ymax)  
  
      common/ trans /xs,xr,yr,ys,xt,yt

      character*5 number
    
      dy = 1000.
      dy2 = dy / 2.
      tic = (xmax-xmin)/ 40.
      t2 = tic / 2.  

      call pssctr (7,1.2,1.2,0.)

      y = 1000. 
   
      do 10 i = 1, 20

         if (y.gt.ymax) goto 99

         write (*,*) ifix(abs(y))

         write (number,1000) ifix(abs(y))

         call psline (xmin, y, xmin+tic, y, 1., 1)
         call psline (xmin, y+dy2, xmin+t2, y+dy2, 1., 1)
         call psline (xmin, y, xmax, y, 8., 0)
         call psline (xmax, y, xmax-tic, y, 1., 1)
         call psline (xmax, y+dy2, xmax-t2, y+dy2, 1., 1)


         call pstext (xmin-5.*tic,y + dcy,number,5)

10    y = y + dy

1000  format (i5)
  
99    end 
c---------------------------------------------------------------
      subroutine psxlabels (xmin,xmax,ymin,ymax)  

      common/ trans /xs,xr,yr,ys,xt,yt
  
      character*4 number
   
      dx = 50.
      dx2 = dx / 2.
      tic = (ymax - ymin) / 40.
      t2 = tic / 2.

      call pssctr (7,1.2,1.2,0.)

      x = xmin 
      y = ymin

      do 10 i = 1, 20

         if (x.gt.xmax) goto 99

         write (*,*) ifix(abs(x))

         write (number,1000) ifix(abs(x))
        
         call psline (x, y, x, y + tic, 1., 1)
         call psline (x+dx2, y, x+dx2, y + t2, 1., 1)
         call psline (x, ymax, x, ymax - tic, 1., 1)  
         call psline (x+dx2, ymax, x+dx2, ymax - t2, 1., 1)
         call psline (x, ymin, x, ymax, 8., 0)       
         call pstext (x, y-1.2*tic, number,4)

10    x = x + dx

1000  format (i4)
  
99    end  
     

