
c these are nag routines modified to solve the phase eq problem, whereby
c the basic constraints are 0<=x<=1 and the general constraints are ax=b

c many of the routines no longer perform the functions indicated in the 
c nag documentation or source comments. 

      subroutine lpnag (n,nclin,a,lda,bl,cvec,istate,x,ax,
     *                  clamda,iw,leniw,w,lenw,ifail,itmax,istart)

c     a  is a constant  nclin by n  matrix.

c     n  is the number of variables (dimension of x).
c        (n must be positive.)

c     nclin  is the number of general linear constraints (rows of  a).
c        (nclin may be zero.)

      integer           mxparm
      parameter         (mxparm=30)
      double precision  zero, point3
      parameter         (zero=0.0d+0,point3=3.3d-1)
      double precision  point8, point9, one
      parameter         (point8=0.8d+0,point9=0.9d+0,one=1.0d+0)
      double precision  hundrd
      parameter         (hundrd=1.0d+2)
      double precision  gigant
      parameter         (gigant=1.0d+20*0.99999d+0)
      double precision  wrktol
      parameter         (wrktol=1.0d-2)
      double precision  obj
      integer           ifail, iter, lda, leniw, lenw, n, nclin
      double precision  a(lda,*), ax(*), bl(nclin), 
     *                  clamda(n+nclin), cvec(*), w(lenw), x(n)
      integer           istate(n+nclin), iw(leniw)
      double precision  alfa, asize,
     *                  dtmax, dtmin, epspt3, epspt5, epspt8, epspt9,
     *                  tolact, tolfea, tolx0, trulam
      integer           isdel, itnfix, jadd, jdel, kchk,ldq, ldt,
     *                  mm, ncolt, ndegen, nn, nnclin
      logical           newopt

      double precision  wmach(15), eps, rmin, rmax

      integer           loclc, nfix(2)

      double precision  amin, condmx, epsmch, errmax, feamax, feamin,
     *                  rteps, xnorm, dnrm2 

      integer           ianrmj, inform, it, j, jinf, jmax,
     *                  lanorm, lcq, ld, ldr, lfeatu, lgq,
     *                  lkactv, lkx,  lq, lr, lrlam, lt, lwrk,
     *                  lwtinf, nact1, nactiv, nartif, nctotl, 
     *                  nfree, ngq, nmoved, nrejtd, nrz, numinf,
     *                  nviol, nz, itmax, ndigit, undflw, nbase

      logical           done, found, halted, rowerr, unitq

      character*6       msg

      common            /ae04mf/loclc(15)
      common            /ax02za/wmach
      common            /be04mf/newopt
      common            /be04nb/ldt, ncolt, ldq
      common            /ce04mf/tolx0, ndegen, itnfix, nfix
      common            /ce04nb/epspt3, epspt5, epspt8, epspt9
      common            /de04mf/alfa, trulam, isdel, jdel, jadd
      common            /de04nb/asize, dtmax, dtmin
      common /fe04mf/kchk, mxfree, maxnz, mm, nn, nnclin
      common            /ge04mf/tolact, tolfea

      ifail = 0 
      iter = 0

      if (istart.ne.0) goto 400
c                                    machine-dependent constants.
         nbase = 2
         ndigit = 53
         eps = 1.11022302462516d-16 
         rmin = 2.22507385850721d-308
         rmax = 1/rmin
         undflw = 0
c
         wmach(1) = nbase
         wmach(2) = ndigit
         wmach(3) = eps
         wmach(4) = sqrt(eps)
         wmach(5) = rmin
         wmach(6) = sqrt(rmin)
         wmach(7) = rmax
         wmach(8) = sqrt(rmax)
         wmach(9) = undflw

      epsmch = wmach(3)
      rteps = wmach(4)
      epspt3 = epsmch**point3
      epspt5 = rteps
      epspt8 = epsmch**point8
      epspt9 = epsmch**point9
      inform = 0
      condmx = max(one/epspt5,hundrd)
c                                           parameters.
      nctotl = n + nclin
      tolact = wrktol
      tolfea = epspt5
      kchk = 50

c     assign the dimensions of arrays in the parameter list of e04mfz.
c     economies of storage are possible if the minimum number of active
c     constraints and the minimum number of fixed variables are known in
c     advance.  the expert user should alter minact and minfxd
c     accordingly.
                        
      maxnz = nclin + 1
      mxfree = nclin + 1
      ldt = nclin + 1
      ncolt = nclin + 1
      ldq = nclin + 1
      ldr = nclin + 1

c     cold start:  nothing initialized
c     hot  start:  the work arrays  iw  and  w  are assumed to have been
c                  initialized during a previous run.
c                  the first three elements of  iw  contain details
c                  on the dimension of the initial working set.

c                                  integer workspace.
      lkactv = 4
      lkx = lkactv + n
      miniw = lkx + n
c                                   real workspace.
      lenq = ldq*ldq
      lencq = n
      lfeatu = 1
      minw = lfeatu + nclin + n
c                                   stuff for e04mfz  and  e04nfz.
      lanorm = minw
      lad = lanorm + nclin
      ld = lad + nclin
      lgq = ld + n
      lcq = lgq + n
      lrlam = lcq + lencq
      lr = lrlam + n
      lt = lr
      lq = lt + ldt*ncolt
      lwtinf = lq + lenq
      lwrk = lwtinf + n + nclin
      minw = lwrk + n + nclin

      loclc(1) = lkactv
      loclc(2) = lkx
      loclc(3) = lfeatu
      loclc(4) = lanorm
      loclc(5) = lad
      loclc(7) = ld
      loclc(8) = lgq
      loclc(9) = lcq
      loclc(10) = lrlam
      loclc(11) = lr
      loclc(12) = lt
      loclc(13) = lq
      loclc(14) = lwtinf
      loclc(15) = lwrk

c     define the initial feasibility tolerances in clamda.

400   call f06fbf(n+nclin,(tolfea),w(lfeatu),1)
      call e04mfr('initialize anti-cycling variables',n,nclin,
     *            nmoved,iter,numinf,istate,clamda,w(lfeatu),x)

      if (istart.eq.0) then
c                                     cold start
         ianrmj = lanorm
         do 20 j = 1, nclin
            w(ianrmj) = dnrm2(n,a(j,1),lda)
            ianrmj = ianrmj + 1
   20    continue

         call f06flf(nclin,w(lanorm),1,asize,amin)
         call f06flf(nctotl,w(lfeatu),1,feamax,feamin)
         call dcopy(nctotl,w(lfeatu),1,w(lwtinf),1)
         call dscal(nctotl,(one/feamin),w(lwtinf),1)

c        define the initial working set.

         call lpinit (nctotl,nactiv,nartif,nfree,n,
     *                istate,iw(lkactv),iw(lkx),tolact,x,w(lgq))

c        compute the tq factorization of the working set matrix.

         unitq = .true.
         nz = nfree
c
         if (nactiv.gt.0) then
            it = nactiv + 1
            nact1 = nactiv
            nactiv = 0
            ngq = 0
c
            call e04nfq(unitq,1,nact1,it,nactiv,nartif,nz,nfree,
     *                  nrejtd,ngq,n,ldq,lda,ldt,istate,iw(lkactv),
     *                  iw(lkx),condmx,a,w(lt),w(lgq),w(lq),w(lwrk),
     *                  w(ld),w(lrlam))
         end if
      else 
c                                       i'm hot
         unitq = iw(1) .eq. 1
         nfree = iw(2)
         nactiv = iw(3)
         nz = nfree - nactiv
      end if

c        install the transformed linear term in cq.

      call dcopy(n,cvec,1,w(lcq),1)
      call e04nbw(6,n,nz,nfree,ldq,unitq,iw(lkx),w(lcq),w(lq),w(lwrk))

      jinf = 0
      nrz = 0

c     repeat               (until working set residuals are acceptable)

c     move x onto the constraints in the working set.

   40 call e04mfj(rowerr,unitq,nclin,nactiv,nfree,nz,n,ldq,lda,ldt,
     *            istate,iw(lkactv),iw(lkx),jmax,errmax,xnorm,a,ax,bl,
     *            w(lfeatu),w(lt),x,w(lq),w(ld),w(lwrk))

      if (rowerr) then
         msg = 'infeas'
         numinf = 1
         obj = errmax
         go to 60
      end if

      call e04mfz(msg,unitq,iter,itmax,
     *            jinf,nviol,n,nclin,lda,nactiv,nfree,nrz,nz,istate,
     *            iw(lkactv),iw(lkx),obj,numinf,xnorm,a,ax,bl,
     *            cvec,clamda,w(lfeatu),x,w)

      found = msg .eq. 'feasbl' .or. msg .eq. 'optiml' .or. msg .eq.
     *        'weak  ' .or. msg .eq. 'unbndd' .or. msg .eq. 'infeas'
      halted = msg .eq. 'itnlim'

      if (found) then
         call e04mfr('optimal',n,nclin,nmoved,iter,numinf,istate,
     *               clamda,w(lfeatu),x)
      end if

      done = found .and. nviol .eq. 0 .and. nmoved .eq. 0

      if ( .not. (done .or. halted)) go to 40

      call e04mfk(nfree,n,nclin,nctotl,nactiv,iw(lkactv),iw(lkx),
     *            clamda,w(lrlam))

      iw(1) = 0
      if (unitq) iw(1) = 1
      iw(2) = nfree
      iw(3) = nactiv

   60 if (msg.eq.'optiml') then
         inform = 0
      else if (msg.eq.'feasbl') then
         inform = 0
      else if (msg.eq.'weak  ') then
         inform = 1
      else if (msg.eq.'unbndd') then
         inform = 2
      else if (msg.eq.'infeas') then
         inform = 3
      else if (msg.eq.'itnlim') then
         inform = 4
      else if (msg.eq.'errors') then
         inform = 6
      end if

      ifail = inform

      istart = 1

      end

      subroutine e04mfk(nfree,n,nclin,nctotl,nactiv,kactiv,kx,
     *           clamda,rlamda)
c     mark 16 release. nag copyright 1992.
c     e04mfk   creates the expanded lagrange multiplier vector clamda.

      double precision  zero
      parameter         (zero=0.0d+0)
      integer           n, nactiv, nclin, 
     *                  nctotl, nfree
      double precision  clamda(nctotl), rlamda(n)
      integer           kactiv(n), kx(n)
      double precision  rlam
      integer           j, k, nfixed, nplin, nz

      nplin = n + nclin
      nz = nfree - nactiv

c     expand multipliers for bounds, linear and nonlinear constraints
c     into the  clamda  array.

      call f06fbf(nctotl,zero,clamda,1)
      nfixed = n - nfree
      do 20 k = 1, nactiv + nfixed
         if (k.le.nactiv) then
            j = kactiv(k) + n
            rlam = rlamda(nactiv-k+1)
         else
            j = kx(nz+k)
            rlam = rlamda(k)
         end if
         clamda(j) = rlam
   20 continue

      end

      subroutine e04mfz(msg,unitq,iter,itmax,
     *                  jinf,nviol,n,nclin,lda,nactiv,nfree,nrz,
     *                  nz,istate,kactiv,kx,obj,numinf,xnorm,a,
     *                  ax,bl,cvec,featol,featlu,x,w)

c     e04mfz  is a subroutine for linear programming.
c     on entry, it is assumed that an initial working set of
c     linear constraints and bounds is available.  the arrays  istate,
c     kactiv  and  kx  will have been set accordingly
c     and the arrays  t  and  q  will contain the tq factorization of
c     the matrix whose rows are the gradients of the active linear
c     constraints with the columns corresponding to the active bounds
c     removed.  the tq factorization of the resulting (nactiv by nfree)
c     matrix is  a(free)*q = (0 t),  where q is (nfree by nfree) and t
c     is upper-triangular.
c
c     over a cycle of iterations, the feasibility tolerance featol
c     increases slightly (from tolx0 to tolx1 in steps of tolinc).
c     this ensures that all steps taken will be positive.
c
c     after kdegen consecutive iterations, variables within featol of
c     their bounds are set exactly on their bounds and iterative
c     refinement is used to satisfy the constraints in the working set.
c     featol is then reduced to tolx0 for the next cycle of iterations.
c
c
c     values of istate(j) for the linear constraints.......
c
c     istate(j)
c     ---------
c          0    constraint j is not in the working set.
c          1    constraint j is in the working set at its lower bound.
c          2    constraint j is in the working set at its upper bound.
c          3    constraint j is in the working set as an equality.
c
c     constraint j may be violated by as much as featol(j).

      integer           mxparm
      parameter         (mxparm=30)
      double precision  zero, one
      parameter         (zero=0.0d+0,one=1.0d+0)
      character*6       empty
      parameter         (empty='      ')
      double precision  obj, xnorm
      integer           iter, jinf, lda, n, nactiv, nclin, nfree,
     *                  nrz, numinf, nviol, nz
      logical           unitq

      character*6       msg

      double precision  a(lda,*), ax(*), bl(nclin), 
     *                  cvec(*), featlu(n+nclin), featol(n+nclin), w(*),
     *                  x(n)
      integer           istate(n+nclin), kactiv(n), kx(n)

      double precision  alfa, asize,   
     *                  dtmax, dtmin, epspt3, epspt5, epspt8, epspt9,
     *                  tolact, tolfea, tolx0, trulam
      integer           isdel, itnfix, jadd, jdel, kchk,
     *                  ldq, ldt, itmax,
     *                  mm, ncolt, ndegen, nn, nnclin

      double precision  wmach(15)
      integer           loclc, nfix(2)
      double precision  alfap, alfhit, bigalf, biggst, condmx, 
     *                  dinky, dnorm, dzz, epsmch, errmax, flmax,
     *                  gfnorm, grznrm, gznorm, objsiz, rtmax, smllst,
     *                  suminf, tinyst, trubig, trusml, wssize, zerolm
      integer           iadd, ifix, inform, is, it, j, jbigst,
     *                  jmax, jsmlst, jtiny, kbigst, kdel, ksmlst, lad,
     *                  lanorm, lcq, ld, ldr, lgq, lq, lr, lrlam, lt,
     *                  ltmp, lwrk, lwtinf, 
     *                  nctotl, ngq, nmoved, notopt, ntfixd
      logical           firstv, hitlow, move, onbnd, overfl,
     *                  unbndd

      double precision  ddot, dnrm2, f06blf

      common            /ae04mf/loclc(15)
      common            /ax02za/wmach
      common            /be04nb/ldt, ncolt, ldq
      common            /ce04mf/tolx0, ndegen, itnfix,nfix
      common            /ce04nb/epspt3, epspt5, epspt8, epspt9
      common            /de04mf/alfa, trulam, isdel, jdel, jadd
      common            /de04nb/asize, dtmax, dtmin
      common /fe04mf/ kchk, mxfree, maxnz, mm, nn, nnclin
      common            /ge04mf/tolact, tolfea
      save              /ax02za/, /ae04mf/, /fe04mf/, /ge04mf/, firstv

c     specify the machine-dependent parameters.

      epsmch = wmach(3)
      flmax = wmach(7)
      rtmax = wmach(8)

      ngq = 2
      ldr = ldt
      it = 1
      lanorm = loclc(4)
      lad = loclc(5)
      ld = loclc(7)
      lgq = loclc(8)
      lcq = loclc(9)
      lrlam = loclc(10)
      lr = loclc(11)
      lt = loclc(12)
      lq = loclc(13)
      lwtinf = loclc(14)
      lwrk = loclc(15)

c     we need a temporary array when changing the active set.
c     use the multiplier array.

      ltmp = lrlam

      if (iter.eq.0) then
         jadd = 0
         jdel = 0
         isdel = 0
         firstv = .false.
         alfa = zero
         dzz = one
      end if

      nctotl = n + nclin
      nviol = 0
      condmx = flmax

      call e04mfh(n,nclin,lda,istate,numinf,suminf,bl,a,
     *            featol,w(lgq),x,w(lwtinf))

      if (numinf.gt.0) then
         call e04nbw(6,n,nz,nfree,ldq,unitq,kx,w(lgq),w(lq),w(lwrk))
      else 
         call dcopy(n,w(lcq),1,w(lgq),1)
      end if
c
      if (numinf.eq.0) then
         obj = ddot(n,cvec,1,x,1)
      else
         obj = suminf
      end if

      msg = empty

c*    ======================start of main loop==========================
c     +    do while (msg .eq. empty)
   20 if (msg.eq.empty) then
c
         gznorm = zero
         if (nz.gt.0) gznorm = dnrm2(nz,w(lgq),1)
c
         if (nrz.eq.nz) then
            grznrm = gznorm
         else
            grznrm = zero
            if (nrz.gt.0) grznrm = dnrm2(nrz,w(lgq),1)
         end if
c
         gfnorm = gznorm
         if (nfree.gt.0 .and. nactiv.gt.0) gfnorm = dnrm2(nfree,w(lgq),
     *       1)

         if (numinf.gt.0) then
            dinky = epspt8*abs(suminf)
         else
            objsiz = one + abs(obj)
            wssize = zero
            if (nactiv.gt.0) wssize = dtmax
            dinky = epspt8*max(wssize,objsiz,gfnorm)
         end if

c        if the reduced gradient z'g is small enough,
c        lagrange multipliers will be computed.
         if (grznrm.le.dinky) then

c           the point  x  is a constrained stationary point.
c           compute lagrange multipliers.
c           define what we mean by 'tiny' and non-optimal multipliers.

            notopt = 0
            jdel = 0
            zerolm = -dinky
            smllst = -dinky
            biggst = dinky + one
            tinyst = dinky

            call e04mfm(n,lda,ldt,nactiv,nfree,nz,istate,
     *                  kactiv,kx,zerolm,notopt,numinf,trusml,smllst,
     *                  jsmlst,ksmlst,tinyst,jtiny,jinf,trubig,biggst,
     *                  jbigst,kbigst,a,w(lanorm),w(lgq),w(lrlam),w(lt),
     *                  w(lwtinf))

            if (nrz.lt.nz) call e04mfl(n,nrz,nz,zerolm,notopt,
     *                                 numinf,trusml,smllst,jsmlst,
     *                                 tinyst,jtiny,w(lgq))

            if (abs(jsmlst).gt.0) then

c              delete a constraint.

c              e04mfm  or  e04mfl  found a non-optimal multiplier.

               trulam = trusml
               jdel = jsmlst

               if (jsmlst.gt.0) then

c                 regular constraint.

                  kdel = ksmlst
                  isdel = istate(jdel)
                  istate(jdel) = 0
               end if
            else
               if (numinf.gt.0 .and. jbigst.gt.0) then

c                 no feasible point exists for the constraints but
c                 the sum of the constraint violations can be reduced
c                 by moving off constraints with multipliers greater
c                 than 1.

                  jdel = jbigst
                  kdel = kbigst
                  isdel = istate(jdel)
                  if (trubig.le.zero) is = -1
                  if (trubig.gt.zero) is = -2
                  istate(jdel) = is
                  trulam = trubig
                  firstv = .true.
                  numinf = numinf + 1
               end if
            end if
c
            if (jdel.eq.0) then
               if (numinf.gt.0) then
                  msg = 'infeas'
               else
                  msg = 'optiml'
               end if
               go to 20
            end if
c
c           constraint  jdel  has been deleted.
c           update the  tq  factorization.
c
            call e04nfp(unitq,it,n,nactiv,nfree,ngq,nz,nrz,lda,ldq,ldt,
     *                  jdel,kdel,kactiv,kx,a,w(lt),w(lgq),w(lq)
     *                  ,w(ld),w(lrlam))
         else

c           compute a search direction.

            if (iter.ge.itmax) then
               msg = 'itnlim'
               go to 20
            end if

            iter = iter + 1

            call dcopy(nrz,w(lgq),1,w(ld),1)
            call dscal(nrz,(-one),w(ld),1)

            dnorm = dnrm2(nrz,w(ld),1)

            call e04nbw(1,n,nrz,nfree,ldq,unitq,kx,w(ld),w(lq),w(lwrk))
            call dgemv('no transpose',nclin,n,one,a,lda,w(ld),1,zero,
     *                 w(lad),1)

c           find the constraint we bump into along d.
c           update  x  and  ax  if the step alfa is nonzero.

c           alfhit is initialized to bigalf. if it remains that value
c           after the call to  e04mfs, it is regarded as infinite.

            bigalf = f06blf(1d20,dnorm,overfl)

            call e04mfs(firstv,n,nclin,istate,bigalf,dnorm,
     *                  hitlow,move,onbnd,unbndd,alfhit,alfap,jadd,
     *                  w(lanorm),w(lad),ax,bl,featol,w(ld),x)

            if (unbndd) then
               msg = 'unbndd'
               go to 20
            end if

            alfa = alfhit
            call daxpy(n,alfa,w(ld),1,x,1)

            call daxpy(nclin,alfa,w(lad),1,ax,1)
            xnorm = dnrm2(n,x,1)

c           add a constraint to the working set.
c           update the  tq  factors of the working set.
c           use  d  as temporary work space.

            if (jadd.gt.n) then
               iadd = jadd - n
               istate(jadd) = 3              
            else
               if (hitlow) then
                  istate(jadd) = 1
               else
                  istate(jadd) = 2
               end if

               if (alfa.ge.zero) then
                  if (hitlow) then
                     x(jadd) = 0d0
                  else
                     x(jadd) = 1d0
                  end if
               end if
               do 40 ifix = 1, nfree
                  if (kx(ifix).eq.jadd) go to 60
   40          continue
   60       end if
c
            call e04nfr(unitq,inform,ifix,iadd,jadd,it,nactiv,nz,
     *                  nfree,ngq,n,lda,ldq,ldt,kx,condmx,a,
     *                  w(lt),w(lgq),w(lq),w(lwrk),w(lrlam),w(ld))
c
            nz = nz - 1
            nrz = nrz - 1
c
            if (jadd.le.n) then
c
c              a simple bound has been added.
c
               nfree = nfree - 1
            else
c
c              a general constraint has been added.
c
               nactiv = nactiv + 1
               kactiv(nactiv) = iadd
            end if
c
c           increment featol.
c
            call daxpy(nctotl,0d0,featlu,1,featol,1)
c
            if (mod(iter,kchk).eq.0) then

c              check the feasibility of constraints with non-
c              negative istate values.  if some violations have
c              occurred.  set inform to force iterative
c              refinement and a switch to phase 1.

               call e04mfq(n,nclin,istate,nviol,jmax,errmax,ax,
     *                     bl,featol,x)
c
            end if
c
            if (mod(iter,999999).eq.0) then
c
c              every  kdegen  iterations, reset  featol  and
c              move  x  on to the working set if it is close.
c
               call e04mfr('end of cycle',n,nclin,nmoved,iter,
     *                     numinf,istate,featol,featlu,x)
c
               nviol = nviol + nmoved
            end if
c
            if (nviol.gt.0) then
               msg = 'resetx'
               go to 20
            end if
c
            if (numinf.ne.0) then
               call e04mfh(n,nclin,lda,istate,numinf,suminf,bl,
     *                     a,featol,w(lgq),x,w(lwtinf))
c
               if (numinf.gt.0) then
                  call e04nbw(6,n,nz,nfree,ldq,unitq,kx,w(lgq),w(lq),
     *                        w(lwrk))
               else 
                  call dcopy(n,w(lcq),1,w(lgq),1)
               end if
            end if
c
            if (numinf.eq.0) then
               obj = ddot(n,cvec,1,x,1)
            else
               obj = suminf
            end if
         end if
         go to 20
c        +    end while
      end if
c     ======================end of main loop============================
c
      if (msg.eq.'optiml') then

            if (nrz.lt.nz) then
               msg = 'weak  '
            else
               ntfixd = 0
               do 80 j = 1, n
                  if (istate(j).eq.4) ntfixd = ntfixd + 1
   80          continue
               if (ntfixd.gt.0) msg = 'weak  '
            end if
            if (abs(jtiny).gt.0) msg = 'weak  '

      else if (msg.eq.'unbndd' .and. numinf.gt.0) then
         msg = 'infeas'
      end if

      end

      subroutine e04mfj(rowerr,unitq,nclin,nactiv,nfree,nz,n,ldq,lda,
     *                  ldt,istate,kactiv,kx,jmax,errmax,xnorm,a,ax,bl,
     *                  featol,t,x,q,p,work)
c     mark 16 release. nag copyright 1992.
c
c     ******************************************************************
c     e04mfj  computes the point on a working set that is closest in the
c     least-squares sense to the input vector x.
c
c     if the computed point gives a row error of more than the
c     feasibility tolerance, an extra step of iterative refinement is
c     used.  if  x  is still infeasible,  the logical variable rowerr
c     is set.
c
c     original version derived from lssetx january-1987.
c     this version of  e04mfj  dated   5-jul-1989.
c     ******************************************************************
      double precision  zero, one
      parameter         (zero=0.0d+0,one=1.0d+0)
      integer           ntry
      parameter         (ntry=5)
c     .. scalar arguments ..
      double precision  errmax, xnorm
      integer           jmax, lda, ldq, ldt, n, nactiv, nclin, nfree, nz
      logical           rowerr, unitq
c     .. array arguments ..
      double precision  a(lda,*), ax(*), bl(nclin), 
     *                  featol(n+nclin), p(n), q(ldq,*), t(ldt,*),
     *                  work(n), x(n)
      integer           istate(n+nclin), kactiv(n), kx(n)
c     .. scalars in common ..
      

c     .. arrays in common ..

c     .. local scalars ..
      double precision  bnd
      integer           i, is, j, k, ktry
c     .. external functions ..
      double precision  ddot, dnrm2
      integer           idamax
c     .. common blocks ..



c     ------------------------------------------------------------------
c     move  x  onto the simple bounds in the working set.
c     ------------------------------------------------------------------
      do 20 k = nfree + 1, n
         j = kx(k)
         is = istate(j)
         bnd = 0d0
         if (is.ge.2) bnd = 1d0
         if (is.ne.4) x(j) = bnd
   20 continue
c     ------------------------------------------------------------------
c     move  x  onto the general constraints in the working set.
c     ntry  attempts are made to get acceptable row errors.
c     ------------------------------------------------------------------
      ktry = 1
      jmax = 1
      errmax = zero
c
c     repeat
c
c        set work = residuals for constraints in the working set.
c        solve for p, the smallest correction to x that gives a point
c        on the constraints in the working set.  define  p = y*(py),
c        where  py  solves the triangular system  t*(py) = residuals.
c
40       do 60 i = 1, nactiv
            k = kactiv(i)
            work(nactiv-i+1) = bl(k) - ddot(n,a(k,1),lda,x,1)
   60    continue
c
         call dtrsv('u','n','n',nactiv,t(1,nz+1),ldt,work,1)
         call f06fbf(n,zero,p,1)
         call dcopy(nactiv,work,1,p(nz+1),1)
         call e04nbw(2,n,nz,nfree,ldq,unitq,kx,p,q,work)
         call daxpy(n,one,p,1,x,1)

c
c     ---------------------------------------------------------------
c     compute the 2-norm of  x.
c     initialize  ax  for all the general constraints.
c     ---------------------------------------------------------------
      xnorm = dnrm2(n,x,1)
      call dgemv('n',nclin,n,one,a,lda,x,1,zero,ax,1)
c
c     ---------------------------------------------------------------
c     check the row residuals.
c     ---------------------------------------------------------------

         do 80 k = 1, nactiv
            i = kactiv(k)
            is = istate(n + i)
            if (is.ne.3) write (*,*) 'is 1',is
            if (is.ge.1) work(k) = bl(i) - ax(i)
   80    continue
c
         jmax = idamax(nactiv,work,1)
         errmax = abs(work(jmax))

      ktry = ktry + 1
c     until    (errmax .le. featol(jmax) .or. ktry .gt. ntry
      if ( .not. (errmax.le.featol(jmax) .or. ktry.gt.ntry)) go to 40
c
      rowerr = errmax .gt. featol(jmax)

      end

      subroutine e04nbw(mode,n,nz,nfree,nq,unitq,kx,v,zy,wrk)
c     mark 12 release. nag copyright 1986.
c     mark 13 revised. ier-590 (mar 1988).
c
c     ******************************************************************
c     e04nbw  transforms the vector  v  in various ways using the
c     matrix  q = ( z  y )  defined by the input parameters.
c
c        mode               result
c        ----               ------
c
c          1                v = z v
c          2                v = y v
c          3                v = q v
c
c     on input,  v  is assumed to be ordered as  ( v(free)  v(fixed) ).
c     on output, v  is a full n-vector.
c
c
c          4                v = z'v
c          5                v = y'v
c          6                v = q'v
c
c     on input,  v  is a full n-vector.
c     on output, v  is ordered as  ( v(free)  v(fixed) ).
c
c          7                v = y'v
c          8                v = q'v
c
c     on input,  v  is a full n-vector.
c     on output, v  is as in modes 5 and 6 except that v(fixed) is not
c     set.
c
c     modes  1, 4, 7 and 8  do not involve  v(fixed).
c     original f66 version  april 1983.
c     fortran 77 version written  9-february-1985.
c     level 2 blas added 10-june-1986.
c     this version of e04nbw dated 10-june-1986.
c     ******************************************************************

      double precision  zero, one
      parameter         (zero=0.0d+0,one=1.0d+0)
      integer           mode, n, nfree, nq, nz
      logical           unitq
      double precision  v(n), wrk(n), zy(nq,*)
      integer           kx(n)
      integer           j, j1, j2, k, l, lenv, nfixed

c
      nfixed = n - nfree
      j1 = 1
      j2 = nfree
      if (mode.eq.1 .or. mode.eq.4) j2 = nz
      if (mode.eq.2 .or. mode.eq.5 .or. mode.eq.7) j1 = nz + 1
      lenv = j2 - j1 + 1
      if (mode.le.3) then
c        ===============================================================
c        mode = 1, 2  or  3.
c        ===============================================================
c
         if (nfree.gt.0) call f06fbf(nfree,zero,wrk,1)
c
c        copy  v(fixed)  into the end of  wrk.
c
         if (mode.ge.2 .and. nfixed.gt.0) call dcopy(nfixed,v(nfree+1),
     *       1,wrk(nfree+1),1)
c
c        set  wrk  =  relevant part of  zy * v.
c
         if (lenv.gt.0) then
            if (unitq) then
               call dcopy(lenv,v(j1),1,wrk(j1),1)
            else
               call dgemv('n',nfree,j2-j1+1,one,zy(1,j1),nq,v(j1),1,one,
     *                    wrk,1)
            end if
         end if
c
c        expand  wrk  into  v  as a full n-vector.
c
         call f06fbf(n,zero,v,1)
         do 20 k = 1, nfree
            j = kx(k)
            v(j) = wrk(k)
   20    continue
c
c        copy  wrk(fixed)  into the appropriate parts of  v.
c
         if (mode.gt.1) then
            do 40 l = 1, nfixed
               j = kx(nfree+l)
               v(j) = wrk(nfree+l)
   40       continue
         end if
c
      else
c        ===============================================================
c        mode = 4, 5, 6, 7  or  8.
c        ===============================================================
c        put the fixed components of  v  into the end of  wrk.
c
         if (mode.eq.5 .or. mode.eq.6) then
            do 60 l = 1, nfixed
               j = kx(nfree+l)
               wrk(nfree+l) = v(j)
   60       continue
         end if
c
c        put the free  components of  v  into the beginning of  wrk.
c
         if (nfree.gt.0) then
            do 80 k = 1, nfree
               j = kx(k)
               wrk(k) = v(j)
   80       continue
c
c           set  v  =  relevant part of  zy' * wrk.
c
            if (lenv.gt.0) then
               if (unitq) then
                  call dcopy(lenv,wrk(j1),1,v(j1),1)
               else
                  call dgemv('t',nfree,j2-j1+1,one,zy(1,j1),nq,wrk,1,
     *                       zero,v(j1),1)
               end if
            end if
         end if
c
c        copy the fixed components of  wrk  into the end of  v.
c
         if (nfixed.gt.0 .and. (mode.eq.5 .or. mode.eq.6))
     *       call dcopy(nfixed,wrk(nfree+1),1,v(nfree+1),1)
      end if

      end


      subroutine e04nfq(unitq,k1,k2,it,nactiv,nartif,nz,nfree,
     *                  nrejtd,ngq,n,ldq,lda,ldt,istate,kactiv,kx,
     *                  condmx,a,t,gqm,q,w,c,s)
c     mark 16 release. nag copyright 1992.
c
c     ******************************************************************
c     e04nfq  includes general constraints  k1  thru  k2  as new rows of
c     the  tq  factorization:
c              a(free) * q(free)  = (  0 t )
c                        q(free)  = (  z y )
c
c     a) the  nactiv x nactiv  upper-triangular matrix  t  is stored
c        with its (1,1) element in position  (it,jt)  of the array  t.
c
c     original version written by peg,  october-31-1984.
c     this version of  e04nfq  dated  7-jul-1989.
c     ******************************************************************

      double precision  zero, one
      parameter         (zero=0.0d+0,one=1.0d+0)

      double precision  condmx
      integer           it, k1, k2, lda, ldq, ldt, n, nactiv,
     *                  nartif, nfree, ngq, nrejtd, nz
      logical           unitq
      double precision  a(lda,*), c(n), gqm(n,*), q(ldq,*), s(n),
     *                  t(ldt,*), w(n)
      integer           istate(*), kactiv(n), kx(n)

      double precision  asize, dtmax, dtmin, epspt3, epspt5, epspt8,
     *                  epspt9
      double precision  wmach(15)
      double precision  cndmax, cond, delta, drzz, dtnew, rnorm, rowmax,
     *                  rtmax, tdtmax, tdtmin
      integer           i, iadd, iartif, ifix, inform, iswap, j, jadd,
     *                  jt, k, l, nzadd
      logical           overfl
      double precision  dnrm2, f06blf
      common            /ax02za/wmach
      common            /ce04nb/epspt3, epspt5, epspt8, epspt9
      common            /de04nb/asize, dtmax, dtmin

      rtmax = wmach(8)
c
      jt = nz + 1
c
c     estimate the condition number of the constraints already
c     factorized.
c
      if (nactiv.eq.0) then
         dtmax = zero
         dtmin = one
         if (unitq) then
c
c           first general constraint added.  set  q = i.
c
            call f06qhf('general',nfree,nfree,zero,one,q,ldq)
            unitq = .false.
         end if
      else
         call f06flf(nactiv,t(it,jt),ldt+1,dtmax,dtmin)
      end if
c
      do 20 k = k1, k2
         iadd = kactiv(k)
         jadd = n + iadd
         if (nactiv.lt.nfree) then

            overfl = .false.
c
c           transform the incoming row of  a  by  q'.
c
            call dcopy(n,a(iadd,1),lda,w,1)
            call e04nbw(8,n,nz,nfree,ldq,unitq,kx,w,q,s)
c
c           check that the incoming row is not dependent upon those
c           already in the working set.
c
            dtnew = dnrm2(nz,w,1)
            if (nactiv.eq.0) then
c
c              this is the first general constraint in the working set.
c
               cond = f06blf(asize,dtnew,overfl)
               tdtmax = dtnew
               tdtmin = dtnew
            else
c
c              there are already some general constraints in the working
c              set. update the estimate of the condition number.
c
               tdtmax = max(dtnew,dtmax)
               tdtmin = min(dtnew,dtmin)
               cond = f06blf(tdtmax,tdtmin,overfl)
            end if
c
            if (cond.ge.condmx .or. overfl) then

c              this constraint appears to be dependent on those already
c              in the working set.  skip it.

               istate(jadd) = 0
               kactiv(k) = -kactiv(k)
            else
               if (nz.gt.1) then

c                 use a single column transformation to reduce the first
c                 nz-1  elements of  w  to zero.

c                 apply the householder reflection  i  -  w w'.
c                 the reflection is applied to  z  and gqm so that
c                    y  =    z  * w,   z    =  z    -  y w'  and
c                    y  =  gqm' * w,   gqm  =  gqm  -  w y',
c                 where  w = wrk1 (from householder),
c                 and    y = wrk2 (workspace).
c
c                 note that delta  has to be stored after the reflection
c                 is used.
c
                  delta = w(nz)
                  call f06frf(nz-1,delta,w,1,zero,w(nz))
                  if (w(nz).gt.zero) then
c
                     call dgemv('n',nfree,nz,one,q,ldq,w,1,zero,s,1)
                     call dger(nfree,nz,(-one),s,1,w,1,q,ldq)
c
                     if (ngq.gt.0) then
                        call dgemv('t',nz,ngq,one,gqm,n,w,1,zero,s,1)
                        call dger(nz,ngq,(-one),w,1,s,1,gqm,n)
                     end if
                  end if
c
                  w(nz) = delta
               end if
               it = it - 1
               jt = jt - 1
               nactiv = nactiv + 1
               nz = nz - 1
               call dcopy(nactiv,w(jt),1,t(it,jt),ldt)
               dtmax = tdtmax
               dtmin = tdtmin
            end if
         end if
   20 continue
c
      if (nactiv.lt.k2) then
c
c        some of the constraints were classed as dependent and not
c        included in the factorization.  re-order the part of  kactiv
c        that holds the indices of the general constraints in the
c        working set.  move accepted indices to the front and shift
c        rejected indices (with negative values) to the end.
c
         l = k1 - 1
         do 40 k = k1, k2
            i = kactiv(k)
            if (i.ge.0) then
               l = l + 1
               if (l.ne.k) then
                  iswap = kactiv(l)
                  kactiv(l) = i
                  kactiv(k) = iswap
               end if
            end if
   40    continue
c
c        if a vertex is required,  add some temporary bounds.
c        we must accept the resulting condition number of the working
c        set.

            cndmax = rtmax
            drzz = one
            nzadd = nz
            do 80 iartif = 1, nzadd
               if (unitq) then
                  ifix = nfree
                  jadd = kx(ifix)
               else
                  rowmax = zero
                  do 60 i = 1, nfree
                     rnorm = dnrm2(nz,q(i,1),ldq)
                     if (rowmax.lt.rnorm) then
                        rowmax = rnorm
                        ifix = i
                     end if
   60             continue
                  jadd = kx(ifix)
c
                  call e04nfr(unitq,inform,ifix,iadd,jadd,it,
     *                        nactiv,nz,nfree,ngq,n,lda,ldq,ldt,
     *                        kx,cndmax,a,t,gqm,q,w,c,s)
               end if
               nfree = nfree - 1
               nz = nz - 1
               nartif = nartif + 1
               istate(jadd) = 4
   80       continue

         if (it.gt.1) then

c           if some dependent constraints were rejected,  move  t  to
c           the top of the array  t.

            do 120 k = 1, nactiv
               j = nz + k
               do 100 i = 1, k
                  t(i,j) = t(it+i-1,j)
  100          continue
  120       continue
         end if
      end if
c
      nrejtd = k2 - nactiv

      end


      subroutine lpinit (nctotl,nactiv,nartif,nfree,n,
     *                   istate,kactiv,kx,tolact,x,wx)

      double precision  tolact
      integer           n, nactiv, nartif, nctotl, nfree

      double precision  wx(n), x(n)
      integer           istate(nctotl), kactiv(n), kx(n)
      integer           is, j, jfix, jfree

c     initialize variables 

      do 20 j = 1, n
         x(j) = 0d0
         wx(j) = 0d0
   20 continue

      nfree = n
      nactiv = 0
      nartif = 0

      do j = 1, n
         istate(j) = 0
      end do 

      do j = n+1, nctotl
         istate(j) = 3
      end do

c     define nfree and kactiv.

      do 80 j = n+1, nctotl
         nactiv = nactiv + 1
         kactiv(nactiv) = j - n
   80 continue
 
c        see if any bounds are violated or nearly satisfied.
c        if so,  add these bounds to the working set and set the
c        variables exactly on their bounds.

         j = n
  100    if (j.ge.1 .and. nactiv.lt.nfree) then
            if (istate(j).eq.0) then
               is = 0
               if (wx(j).le.tolact) is = 1
               if (1d0-wx(j).le.2d0*tolact) is = 2
               if (is.gt.0) then
                  istate(j) = is
                  if (is.eq.1) wx(j) = 0d0
                  if (is.eq.2) wx(j) = 1d0
                  nfree = nfree - 1
               end if
            end if
            j = j - 1
            go to 100
         end if

      jfree = 1
      jfix = nfree + 1
      do 280 j = 1, n
         if (istate(j).le.0) then
            kx(jfree) = j
            jfree = jfree + 1
         else
            kx(jfix) = j
            jfix = jfix + 1
         end if
  280 continue

      end

      subroutine e04mfr(job,n,nclin,nmoved,iter,numinf,istate,
     *                  featol,featlu,x)
c     mark 16 release. nag copyright 1992.
c
c     ******************************************************************
c     e04mfr performs most of the manoeuvres associated with degeneracy.
c     the degeneracy-resolving strategy operates in the following way.
c
c     over a cycle of iterations, the feasibility tolerance featol
c     increases slightly (from tolx0 to tolx1 in steps of tolinc).
c     this ensures that all steps taken will be positive.
c
c     after kdegen consecutive iterations, variables within
c     featol of their bounds are set exactly on their bounds and x is
c     recomputed to satisfy the general constraints in the working set.
c     featol is then reduced to tolx0 for the next cycle of iterations.
c
c     featlu  is the array of user-supplied feasibility tolerances.
c     featol  is the array of current feasibility tolerances.
c
c     if job = 'i', e04mfr initializes the parameters in
c     kdegen  is the expand frequency (specified by the user).
c             it is the frequency of resetting featol to (scaled) tolx0.
c     ndegen  counts the number of degenerate steps (incremented
c             by e04mfs).
c     itnfix  is the last iteration at which a job = 'e' or 'o' entry
c             caused an x to be put on a constraint.
c     common block ce04mf:
c
c     tolx0   is the minimum (scaled) feasibility tolerance.
c     tolx1   is the maximum (scaled) feasibility tolerance.
c     tolinc  is the scaled increment to the current featol.
c     nfix(j) counts the number of times a job = 'o' entry has
c             caused the variables to be placed on the working set,
c             where j=1 if infeasible, j=2 if feasible.
c
c     tolx0*featlu and tolx1*featlu are both close to the feasibility
c     tolerance featlu specified by the user.  (they must both be less
c     than featlu.)
c
c
c     if job = 'e',  e04mfr has been called after a cycle of kdegen
c     iterations.  constraints in the working set are examined to see if
c     any are off their bounds by an amount approaching featol.  nmoved
c     returns how many.  if nmoved is positive,  x  is moved onto the
c     constraints in the working set.  it is assumed that the calling
c     routine will then continue iterations.
c
c
c     if job = 'o',  e04mfr is being called after a subproblem has been
c     judged optimal, infeasible or unbounded.  constraint violations
c     are examined as above.
c
c     e04mfr is based on minos 5.2 routine m5dgen,
c
c     original version dated  19-april 1988.
c     this version of  e04mfr  dated 13-dec-1990.
c     ******************************************************************
c
c     .. parameters ..
      double precision  zero, point6
      parameter         (zero=0.0d+0,point6=0.6d+0)
c     .. scalar arguments ..

      integer           iter, n, nclin, nmoved, numinf
      character         job
c     .. array arguments ..
      double precision  featlu(n+nclin), featol(n+nclin), x(n)
      integer           istate(n+nclin)
c     .. scalars in common ..
      double precision  tolx0
      integer           itnfix, ndegen
      double precision  wmach(15)
      integer           nfix(2)
      double precision  d, epsmch, tolx1, tolz
      integer           is, j, maxfix
      common            /ax02za/wmach
      common            /ce04mf/tolx0, ndegen, itnfix,
     *                  nfix
c     .. save statement ..
      save              /ax02za/, tolz

c
      nmoved = 0
      if (job.eq.'i' .or. job.eq.'i') then

c        job = 'initialize'.
c        initialize at the start of each linear problem.
c        kdegen  is the expand frequency      and
c        featlu  are the user-supplied feasibility tolerances.
c        they are not changed.

         epsmch = wmach(3)
c
         ndegen = 0
         itnfix = 0
         nfix(1) = 0
         nfix(2) = 0
         tolx0 = 0.5d+0
         tolx1 = 0.99d+0
         tolz = epsmch**point6

         do 20 j = 1, n + nclin
            featol(j) = tolx0*featlu(j)
   20    continue
      else

c        job = 'end of cycle' or 'optimal'.
c        initialize local variables maxfix and tolz.

         maxfix = 2
c
         if (job.eq.'o' .or. job.eq.'o') then

c           job = 'optimal'.
c           return with nmoved = 0 if the last call was at the same
c           iteration,  or if there have already been maxfix calls with
c           the same state of feasibility.

            if (itnfix.eq.iter) return
            if (numinf.gt.0) then
               j = 1
            else
               j = 2
            end if

            if (nfix(j).ge.maxfix) return
            nfix(j) = nfix(j) + 1
         end if

c        reset featol to its minimum value.

         do 40 j = 1, n + nclin
            featol(j) = tolx0*featlu(j)
   40    continue

c        count the number of times a variable is moved a nontrivial
c        distance onto its bound.

         itnfix = iter

         do 60 j = 1, n
            is = istate(j)
            if (is.gt.0 .and. is.lt.4) then
               if (is.eq.1) then
                  d = abs(x(j))
               else
                  d = abs(x(j)-1d0)
               end if
c
               if (d.gt.tolz) nmoved = nmoved + 1
            end if
   60    continue
c
      end if

      end

      subroutine e04mfq(n,nclin,istate,nviol,jmax,errmax,ax,bl,
     *                  featol,x)
c     mark 16 release. nag copyright 1992.

c     e04mfq  checks the residuals of the constraints that are believed
c     to be feasible.  the number of constraints violated by more than
c     featol is computed, along with the maximum constraint violation.

      double precision  zero
      parameter         (zero=0.0d+0)
c     .. scalar arguments ..
      double precision  errmax
      integer           jmax, n, nclin, nviol
c     .. array arguments ..
      double precision  ax(*), bl(nclin), 
     *                  featol(n+nclin), x(n)
      integer           istate(n+nclin)
c     .. local scalars ..
      double precision  con, feasj, res
      integer           is, j

c     compute the number of constraints (nviol) violated by more than
c     featol and  the maximum constraint violation (errmax).
c     (the residual of a constraint in the working set is treated as if
c     it were an equality constraint fixed at that bound.)

      nviol = 0
      jmax = 0
      errmax = zero
c
      do 40 j = 1, n + nclin
         is = istate(j)
c
         if (is.ge.0) then
            feasj = featol(j)
c
            if (j.le.n) then
               con = x(j)
            else
               con = ax(j-n)
            end if
c           check for constraint violations.

            if (j.le.n) then 
               res = -con
               if (res.gt.feasj) then
                  nviol = nviol + 1
                  go to 20
               end if

               res = 1d0 - con
               if (res.lt.(-feasj)) then
                  nviol = nviol + 1
                  res = -res
                  go to 20
               end if
c           this constraint is satisfied,  but count a large residual
c           as a violation if the constraint is in the working set.
               res = zero

               if (is.eq.1) then
               res = abs(con)

               else if (is.eq.2) then
               res = abs(1d0-con)

               else if (is.eq.3) then
               res = abs(1d0-con)
               end if
            else 
               res = bl(j-n) - con
               if (res.gt.feasj) then
                  nviol = nviol + 1
                  go to 20
               end if

c           this constraint is satisfied,  but count a large residual
c           as a violation if the constraint is in the working set.

               res = zero

               if (is.eq.1) then
               res = abs(bl(j-n)-con)

               else if (is.eq.2) then
               res = abs(bl(j-n)-con)

               else if (is.eq.3) then
               res = abs(bl(j-n)-con)
               end if
            end if 

            if (res.gt.feasj) nviol = nviol + 1

   20       if (res.gt.errmax) then
               jmax = j
               errmax = res
            end if
         end if
   40 continue

      end

      subroutine e04mfs(firstv,n,nclin,istate,bigalf,pnorm,
     *                  hitlow,move,onbnd,unbndd,alfa,alfap,jhit,anorm,
     *                  ap,ax,bl,featol,p,x)
c     mark 16 release. nag copyright 1992.

c     e04mfs  finds a step alfa such that the point x + alfa*p reaches
c     one of the linear constraints (including bounds).
c
c     in this version of e04mfs, when x is infeasible, the number of
c     infeasibilities will never increase.  if the number stays the
c     same, the sum of infeasibilities will decrease.  if the number
c     decreases by one or more,  the sum of infeasibilities will usually
c     decrease also, but occasionally it will increase after the step
c     alfa  is taken.  (convergence is still assured because the number
c     has decreased.)
c
c     three possible steps are computed as follows:
c
c     alfaf = the maximum step that can be taken without violating
c              one of the constraints that are currently satisfied.
c
c     alfai = reaches a linear constraint that is currently violated.
c              usually this will be the furthest such constraint along
c              p, subject to the angle between the constraint normal and
c              p being reasonably close to the maximum value among
c              infeasible constraints,  but if firstv = .true. it will
c              be the first one along p.  the latter case applies only
c              when the problem has been determined to be infeasible,
c              and the sum of infeasibilities are being minimized.
c              (alfai is not defined when x is feasible.)
c
c     alfai is needed occasionally when infeasible, to prevent
c     going unnecessarily far when alfaf is quite large.  it will
c     always come into effect when x is about to become feasible.
c     (the sum of infeasibilities will decrease initially as alfa
c     increases from zero, but may start increasing for larger steps.
c     choosing a large alfai allows several elements of  x  to
c     become feasible at the same time.
c
c     in the end, we take  alfa = alfaf  if x is feasible, or if
c     alfai > alfap (where  alfap  is the perturbed step from pass 1).
c     otherwise,  we take  alfa = alfai.
c
c     input parameters
c     ----------------
c     bigalf defines what should be treated as an unbounded step.
c     bigbnd provides insurance for detecting unboundedness.
c            if alfa reaches a bound as large as  it is
c            classed as an unbounded step.
c     featol is the array of current feasibility tolerances used by
c            e04mfh.  typically in the range 0.5*tolx to 0.99*tolx,
c            where tolx is the featol specified by the user.
c     tolinc (in common) is used to determine stepmn (see below),
c            the minimum positive step.
c     istate is set as follows:
c            istate(j) = -2  if a'x .lt. bl - featol
c                      = -1  if a'x .gt. bu + featol
c                      =  0  if a'x is not in the working set
c                      =  1  if a'x is in the working set at bl
c                      =  2  if a'x is in the working set at bu
c                      =  3  if a'x is in the working set (an equality)
c                      =  4  if x(j) is temporarily fixed.
c            values -2 and -1 do not occur once feasible.
c     bl     the lower bounds on the variables.
c     x      the values of       ditto.
c     p      the search direction.
c
c
c     output parameters
c     -----------------
c     hitlow  = true  if a lower bound restricted alfa.
c             = false otherwise.
c     move    = true  if  exact ge stepmn  (defined at end of code).
c     onbnd   = true  if  alfa = exact.  this means that the step  alfa
c                     moves x  exactly onto one of its constraints,
c                     namely  bound.
c             = false if the exact step would be too small
c                     ( exact .lt. stepmn ).
c               (with these definitions,  move = onbnd).
c     unbndd  = true  if alfa = bigalf.  jhit may possibly be zero.
c               the parameters hitlow, move, onbnd, bound and exact
c               should not be used.
c     jhit    = the index (if any) such that constraint jhit reaches
c               a bound.
c     bound   = the bound value bl(jhit) or bu(jhit) corresponding
c               to hitlow.
c     exact   = the step that would take constraint jhit exactly onto
c               bound.
c     alfa    = an allowable, positive step.
c               if unbndd is true,  alfa = stepmx.
c               otherwise,          alfa = max( stepmn, exact ).
c
c
c     e04mfs is based on minos 5.2 routine m5chzr, which implements the
c     expand procedure to deal with degeneracy. the step alfaf is
c     chosen as in the two-pass approach of paula harris (1973), except
c     that this version insists on returning a positive step, alfa.
c     two features make this possible:
c
c        1. featol increases slightly each iteration.
c
c        2. the blocking constraint, when added to the working set,
c           retains the value ax(jhit) + alfa * ap(jhit),
c           even if this is not exactly on the blocking bound.
c
c     for infeasible variables moving towards their bound, we require
c     the rate of change of the chosen constraint to be at least gamma
c     times as large as the biggest available.  this still gives us
c     freedom in pass 2.
c     gamma = 0.1 and 0.01 seemed to inhibit phase 1 somewhat.
c     gamma = 0.001 seems to be safe.

      double precision  zero, one
      parameter         (zero=0.0d+0,one=1.0d+0)
      double precision  gamma
      parameter         (gamma=1.0d-3)
c     .. scalar arguments ..
      double precision  alfa, alfap, bigalf, pnorm
      integer           jhit, n, nclin
      logical           firstv, hitlow, move, onbnd, unbndd
c     .. array arguments ..
      double precision  anorm(*), ap(*), ax(*), bl(nclin),
     *                  featol(n+nclin),
     *                  p(n), x(n)
      integer           istate(n+nclin)

      double precision  epspt3, epspt5, epspt8, epspt9, tolx0
      integer           itnfix, ndegen
      integer           nfix(2)
      double precision  alfai, atp, atpabs, atpmxf, atpmxi, atpscd, atx,
     *                  bound, delta, exact, res,
     *                  stepmn, tolpiv
      integer           i, j, jhitf, jhiti, js
      logical           blockf, blocki

      common            /ce04mf/tolx0, ndegen, itnfix, nfix
      common            /ce04nb/epspt3, epspt5, epspt8, epspt9

c     tolpiv is a tolerance to exclude negligible elements of a'p.

      tolpiv = epspt9*pnorm

c     first pass -- find steps to perturbed constraints, so that
c     alfap will be slightly larger than the true step.
c     in degenerate cases, this strategy gives us some freedom in the
c     second pass.  the general idea follows that described by p.m.j.
c     harris, p.21 of mathematical programming 5, 1 (1973), 1--28.

      atpmxi = zero
      alfap = bigalf
c
      do 20 j = 1, n + nclin
         js = istate(j)
c
         if (js.le.0) then
            delta = featol(j)
c
            if (j.le.n) then
               atx = x(j)
               atp = p(j)
               atpabs = abs(atp)
               atpscd = atpabs
            else
               i = j - n
               atx = ax(i)
               atp = ap(i)
               atpabs = abs(atp)
               atpscd = atpabs/(one+anorm(i))
            end if
c
            if (atpscd.le.tolpiv) then

c              this constraint appears to be constant along p.  it is
c              not used to compute the step.  give the residual a value
c              that can be spotted in the debug output.

               res = -one
c
            else if (atp.le.zero .and. js.ne.-2) then

c              a'x  is decreasing and the lower bound is not violated.

c              test for smaller alfap.
c              if the upper bound is violated. test for bigger atp.
c
               if (j.le.n) then 
                   res = atx + delta                    
                  if (res.lt.alfap*atpabs) alfap = res/atpabs
               else                  
                  res = atx - bl(j-n) + delta 
                  if (res.lt.alfap*atpabs) alfap = res/atpabs
               end if 
c
               if (js.eq.-1) atpmxi = max(atpmxi,atpscd)
c
            else if (atp.gt.zero .and. js.ne.-1) then

c              a'x  is increasing and the upper bound is not violated.

c              test for smaller alfap.
c              if the lower bound is violated. test for bigger atp.
c
               if (j.le.n) then 
                  res = 1d0 - atx + delta
                  if (res.lt.alfap*atp) alfap = res/atp
               else 
                  res = bl(j-n) - atx + delta
                  if (res.lt.alfap*atp) alfap = res/atp
               end if 
c
               if (js.eq.-2) atpmxi = max(atpmxi,atpscd)
            end if

         end if
   20 continue

c     second pass.
c     for feasible variables, recompute steps without perturbation.
c     amongst constraints that are closer than alfap, choose the one
c     that makes the largest angle with the search direction.
c     for infeasible variables, find the largest step subject to a'p
c     being no smaller than gamma * max(a'p).

      if (firstv) then
         alfai = bigalf
      else
         alfai = zero
      end if
c
      atpmxf = zero
      atpmxi = gamma*atpmxi
      jhitf = 0
      jhiti = 0
c
      do 40 j = 1, n + nclin
         js = istate(j)
c
         if (js.le.0) then
c
            if (j.le.n) then
               atx = x(j)
               atp = p(j)
               atpabs = abs(atp)
               atpscd = atpabs
            else
               i = j - n
               atx = ax(i)
               atp = ap(i)
               atpabs = abs(atp)
               atpscd = atpabs/(one+anorm(i))
            end if
c
            if (atpscd.le.tolpiv) then

c              this constraint appears to be constant along p.  it is
c              not used to compute the step.  give the residual a value
c              that can be spotted in the debug output.

               res = -one
c
            else if (atp.le.zero .and. js.ne.-2) then

c              a'x  is decreasing.

c              test for bigger a'p if the lower bound is satisfied.
c              test for smaller alfaf.
c
               if (atpscd.gt.atpmxf) then

                  if (j.le.n) then 
                     res = atx 
c
                     if (res.le.alfap*atpabs) then
                        atpmxf = atpscd
                        jhitf = j
                     end if
                   else 
                     res = atx - bl(j-n)
c
                     if (res.le.alfap*atpabs) then
                        atpmxf = atpscd
                        jhitf = j
                     end if
                   end if 
               end if
c
               if (js.eq.-1) then
c                 the upper bound is violated.
c                 test for bigger or smaller alfai,  depending on the
c                 value of firstv.
                  if (j.le.n) then 
                  if (firstv) then
                     res = atx - 1d0
c
                     if (res.le.alfai*atpabs) then
                        alfai = res/atpabs
                        jhiti = j
                     end if
c
                  else if (atpscd.ge.atpmxi) then
                     res = atx - 1d0
c
                     if (res.gt.alfai*atpabs) then
                        alfai = res/atpabs
                        jhiti = j
                     end if
                  end if
                  else 
                  if (firstv) then
                     res = atx - bl(j-n)
c
                     if (res.le.alfai*atpabs) then
                        alfai = res/atpabs
                        jhiti = j
                     end if
c
                  else if (atpscd.ge.atpmxi) then
                     res = atx - bl(j-n)
c
                     if (res.gt.alfai*atpabs) then
                        alfai = res/atpabs
                        jhiti = j
                     end if
                  end if
                  
                  end if 
               end if
c
            else if (atp.gt.zero .and. js.ne.-1) then

c              a'x  is increasing and the upper bound is not violated.

c              test for smaller alfap.
c
               if (atpscd.gt.atpmxf) then
c
                  if (j.le.n) then 
                     res = 1d0 - atx
                     if (res.le.alfap*atp) then
                        atpmxf = atpscd
                        jhitf = j
                     end if
                  else 
                     res = bl(j-n) - atx
                     if (res.le.alfap*atp) then
                        atpmxf = atpscd
                        jhitf = j
                     end if

                  end if 
               end if
c
               if (js.eq.-2) then
c                 the lower bound is violated.
c                 test for bigger or smaller alfai,  depending on the
c                 value of firstv.
               if (j.le.n) then       
                  if (firstv) then
                     res = -atx
c
                     if (res.le.alfai*atp) then
                        alfai = res/atp
                        jhiti = j
                     end if
                  else if (atpscd.ge.atpmxi) then
                     res = - atx
c
                     if (res.gt.alfai*atp) then
                        alfai = res/atp
                        jhiti = j
                     end if
                  end if       
               else
                  res = bl(j-n) - atx
                  if (firstv) then
                     if (res.le.alfai*atp) then
                        alfai = res/atp
                        jhiti = j
                     end if
                  else if (atpscd.ge.atpmxi) then
                     if (res.gt.alfai*atp) then
                        alfai = res/atp
                        jhiti = j
                     end if
                  end if
               end if
               end if 
            end if
         end if
   40 continue
c
c     ------------------------------------------------------------------
c     see if a feasible and/or infeasible constraint blocks.
c     ------------------------------------------------------------------
      blockf = jhitf .gt. 0
      blocki = jhiti .gt. 0
      unbndd = .not. (blockf .or. blocki)
c
      if (unbndd) go to 60
c
      if (blockf) then

c        a constraint is hit which is currently feasible.
c        the corresponding step alfaf is not used, so no need to get it,
c        but we know that alfaf .le. alfap, the step from pass 1.

         jhit = jhitf
         if (jhit.le.n) then
            atp = p(jhit)
         else
            atp = ap(jhit-n)
         end if
         hitlow = atp .lt. zero
      end if
c
c     if there is a choice between alfaf and alfai, it is probably best
c     to take alfai.  however, we can't if alfai is bigger than alfap.
c
      if (blocki .and. alfai.le.alfap) then

c        an infeasible variable reaches its violated bound.

         jhit = jhiti
         if (jhit.le.n) then
            atp = p(jhit)
         else
            atp = ap(jhit-n)
         end if
         hitlow = atp .gt. zero
      end if
c
      if (jhit.le.n) then
         atx = x(jhit)
      else
         atx = ax(jhit-n)
      end if

c     try to step exactly onto bound, but make sure the exact step
c     is sufficiently positive.  (exact will be alfaf or alfai.)
c     since featol increases by  tolinc  each iteration, we know that
c     a step as large as  stepmn  (below) will not cause any feasible
c     variables to become infeasible (where feasibility is measured
c     by the current featol).

      if (jhit.le.n) then 
      if (hitlow) then
         bound = 0d0
      else
         bound = 1d0
      end if
      else 
         bound = bl(jhit-n)
      end if 
c
      stepmn = 0d0
      exact = (bound-atx)/atp
      alfa = max(stepmn,exact)
      onbnd = alfa .eq. exact
      move = exact .ge. stepmn
      if ( .not. move) ndegen = ndegen + 1
c
      return

c     unbounded.

   60 alfa = bigalf
      move = .true.
      onbnd = .false.

      end

      subroutine e04nfr(unitq,inform,ifix,iadd,jadd,it,nactiv,nz,
     *                  nfree,ngq,n,lda,ldq,ldt,kx,condmx,
     *                  a,t,gqm,q,w,c,s)

c     e04nfr  updates the matrices  z, y, t, r  and  d  associated with
c     factorizations
c
c              a(free) * q(free)  = (  0 t )
c                        q(free)  = (  z y )
c                      r' *d * r  =   hz
c
c     a) the matrices  r  and  t  are upper triangular.
c     b) the arrays  t  and  r  may be the same array.
c     c) the  nactiv x nactiv  upper-triangular matrix  t  is stored
c        with its (1,1) element in position  (it,jt) of the
c        array  t.   the integer  jt  is always  nz+1.  during regular
c        changes to the working set,  it = 1;  when several constraints
c        are added simultaneously,  it  points to the first row of the
c        existing  t.
c     d) the matrix  r  is stored in the first  nz x nz  rows
c        and columns of the  nfree x nfree  leading principal minor of
c        the array  r.

c
c     there are three separate cases to consider (although each case
c     shares code with another)...
c
c     (1) a free variable becomes fixed on one of its bounds when there
c         are already some general constraints in the working set.
c
c     (2) a free variable becomes fixed on one of its bounds when there
c         are only bound constraints in the working set.
c
c     (3) a general constraint (corresponding to row  iadd  of  a) is
c         added to the working set.
c
c     in cases (1) and (2), we assume that  kx(ifix) = jadd.
c     in all cases,  jadd  is the index of the constraint being added.
c
c     if there are no general constraints in the working set,  the
c     matrix  q = (z y)  is the identity and will not be touched.
c
c     if  ngq .gt. 0,  the column transformations are applied to the
c     columns of the  (ngq x n)  matrix  gqm'.

      double precision  zero, one
      parameter         (zero=0.0d+0,one=1.0d+0)

      double precision  condmx
      integer           iadd, ifix, inform, it, jadd, lda, ldq,
     *                  ldt, n, nactiv, nfree, ngq, nz
      logical           unitq

      double precision  a(lda,*), c(n), gqm(n,*), q(ldq,*),
     *                  s(n), t(ldt,*), w(n)
      integer           kx(n)
c     .. scalars in common ..
      double precision  asize, dtmax, dtmin, epspt3, epspt5, epspt8,
     *                  epspt9
      double precision  cond, condbd, dtnew, tdtmax, tdtmin
      integer           i, j, jt, k, nanew, npiv
      logical           bound, overfl

      double precision  dnrm2, f06blf

      common            /ce04nb/epspt3, epspt5, epspt8, epspt9
      common            /de04nb/asize, dtmax, dtmin

c     if the condition estimator of the updated t is greater than
c     condbd,  a warning message is printed.

      condbd = one/epspt9
c
      overfl = .false.
      bound = jadd .le. n
      jt = nz + 1
c
      if (bound) then
c        ===============================================================
c        a simple bound has entered the working set.  iadd is not used.
c        ===============================================================

         nanew = nactiv
c
         if (unitq) then
c
c           q is not stored, but  kx  defines an ordering of the columns
c           of the identity matrix that implicitly define q.
c           define the sequence of pairwise interchanges p that moves
c           the newly-fixed variable to position  nfree.
c           reorder  kx  accordingly.
c
            do 20 i = 1, nfree - 1
               if (i.ge.ifix) then
                  w(i) = i + 1
                  kx(i) = kx(i+1)
               else
                  w(i) = i
               end if
   20       continue
         else

c           q  is stored explicitly.

c           set  w = the  (ifix)-th  row of  q.
c           move the  (nfree)-th  row of  q  to position ifix.
c
            call dcopy(nfree,q(ifix,1),ldq,w,1)
            if (ifix.lt.nfree) then
               call dcopy(nfree,q(nfree,1),ldq,q(ifix,1),ldq)
               kx(ifix) = kx(nfree)
            end if
         end if
         kx(nfree) = jadd
      else
c        ===============================================================
c        a general constraint has entered the working set.
c        ifix is not used.
c        ===============================================================
c
         nanew = nactiv + 1
c
c        transform the incoming row of a by q'.
c
         call dcopy(n,a(iadd,1),lda,w,1)
         call e04nbw(8,n,nz,nfree,ldq,unitq,kx,w,q,c)
c
c        check that the incoming row is not dependent upon those
c        already in the working set.
c
         dtnew = dnrm2(nz,w,1)
         if (nactiv.eq.0) then
c
c           this is the only general constraint in the working set.
c
            cond = f06blf(asize,dtnew,overfl)
            tdtmax = dtnew
            tdtmin = dtnew
         else
c
c           there are already some general constraints in the working
c           set.  update the estimate of the condition number.
c
            tdtmax = max(dtnew,dtmax)
            tdtmin = min(dtnew,dtmin)
            cond = f06blf(tdtmax,tdtmin,overfl)
         end if
c
         if (cond.gt.condmx .or. overfl) go to 80
c
         if (unitq) then
c
c           first general constraint added.  set  q = i.
c
            call f06qhf('general',nfree,nfree,zero,one,q,ldq)
            unitq = .false.
            it = 0
         end if
      end if
c
      if (bound) then
         npiv = nfree
      else
         npiv = nz
      end if
c
      if (unitq) then

c        the orthogonal matrix  q  (i.e.,  q) is not stored explicitly.
c        apply  p, the sequence of pairwise interchanges that moves the
c        newly-fixed variable to position  nfree.

         if (ngq.gt.0) call f06qkf('left','transpose',nfree-1,w,ngq,gqm,
     *                             n)
      else

c        the matrix  q  is stored explicitly.
c        define a sweep of plane rotations p such that
c                           pw = beta*e(npiv).
c        the rotations are applied in the planes (1, 2), (2, 3), ...,
c        (npiv-1, npiv).  the rotations must be applied to q, gqm', r
c        and t.

         call f06fqf('varble','forwrds',npiv-1,w(npiv),w,1,c,s)
c
         if (ngq.gt.0) call f06qxf('left ','variable','forwards',npiv,
     *                             ngq,1,npiv,c,s,gqm,n)
         call f06qxf('right','variable','forwards',nfree,nfree,1,npiv,c,
     *               s,q,ldq)
      end if
c
      if ( .not. unitq) then
         if (bound) then

c           bound constraint added.   the rotations affect columns
c           nz+1  thru  nfree  of  gqm'  and  t.

c           the last row and column of  q  has been transformed to plus
c           or minus the unit vector  e(nfree).  we can reconstitute the
c           column of gqm' corresponding to the new fixed variable.
c
            if (w(nfree).lt.zero) then
               if (ngq.gt.0) call dscal(ngq,-one,gqm(nfree,1),n)
            end if
c
            if (nactiv.gt.0) then
               t(it,jt-1) = s(jt-1)*t(it,jt)
               t(it,jt) = c(jt-1)*t(it,jt)
c
               if (nactiv.gt.1) then
                  call f06qvf('right',nactiv,1,nactiv,c(jt),s(jt),
     *                        t(it,jt),ldt)
                  call dcopy(nactiv-1,s(jt),1,t(it+1,jt),ldt+1)
               end if
c
               jt = jt - 1
               call f06flf(nactiv,t(it,jt),ldt+1,tdtmax,tdtmin)
               cond = f06blf(tdtmax,tdtmin,overfl)
            end if
         else

c           general constraint added.  install  w  at the front of  t.
c           if there is no room,  shift all the rows down one position.

            it = it - 1
            if (it.le.0) then
               it = 1
               do 60 k = 1, nactiv
                  j = jt + k - 1
                  do 40 i = k, 1, -1
                     t(i+1,j) = t(i,j)
   40             continue
   60          continue
            end if
            jt = jt - 1
            call dcopy(nanew,w(jt),1,t(it,jt),ldt)
         end if
      end if

c     prepare to exit.  check the magnitude of the condition estimator.

   80 if (nanew.gt.0) then
         if (cond.lt.condmx .and. .not. overfl) then
c
c           the factorization has been successfully updated.
c
            inform = 0
            dtmax = tdtmax
            dtmin = tdtmin

         else

c           the proposed working set appears to be linearly dependent.

            inform = 1
         end if
      end if

      end


      subroutine e04nfp(unitq,it,n,nactiv,nfree,ngq,nz,nrz,lda,ldq,ldt,
     *                  jdel,kdel,kactiv,kx,a,t,gqm,q,c,s)

c     e04nfp   updates the matrices  z, y, t, r  and  d  associated with
c     factorizations
c
c              a(free) * q(free)  = (  0 t )
c                        q(free)  = (  z y )
c
c     when a regular, temporary or artificial constraint is deleted
c     from the working set.
c
c     the  nactiv x nactiv  upper-triangular matrix  t  is stored
c     with its (1,1) element in position  (it,jt)  of the array  t.

      double precision  zero, one
      parameter         (zero=0.0d+0,one=1.0d+0)
c     .. scalar arguments ..
      integer           it, jdel, kdel, lda, ldq, ldt, n, nactiv, nfree,
     *                  ngq, nrz, nz
      logical           unitq
c     .. array arguments ..
      double precision  a(lda,*), c(n), gqm(n,*), q(ldq,*), s(n), 
     *                  t(ldt,*)

      integer           kactiv(n), kx(n)
c     .. scalars in common ..
      double precision  asize, dtmax, dtmin
c     .. local scalars ..
      double precision  cs, sn
      integer           i, ir, itdel, j, jart, jt, k, l, npiv, nrz1,
     *                  nsup
c     .. external functions ..
      integer           idamax

      common            /de04nb/asize, dtmax, dtmin

      jt = nz + 1
c
      if (jdel.gt.0) then

c        regular constraint or temporary bound deleted.

         if (jdel.le.n) then

c           case 1.  a simple bound has been deleted.
c           =======  columns  nfree+1  and  ir  of gqm' must be swapped.

            ir = nz + kdel

            itdel = nactiv + 1
            nfree = nfree + 1
            if (nfree.lt.ir) then
               kx(ir) = kx(nfree)
               kx(nfree) = jdel
               call dswap(ngq,gqm(nfree,1),n,gqm(ir,1),n)
            end if

            if ( .not. unitq) then

c              copy the incoming column of  a(free)  into the end of  t.

               do 20 k = 1, nactiv
                  i = kactiv(k)
                  t(nactiv-k+1,nfree) = a(i,jdel)
   20          continue

c              expand  q  by adding a unit row and column.

               if (nfree.gt.1) then
                  call f06fbf(nfree-1,zero,q(nfree,1),ldq)
                  call f06fbf(nfree-1,zero,q(1,nfree),1)
               end if
               q(nfree,nfree) = one
            end if
         else
c           case 2.  a general constraint has been deleted.

c           delete row  itdel  of  t  and move up the ones below it.
c           t  becomes lower hessenberg.

            itdel = kdel
            do 60 k = itdel, nactiv
               j = jt + k - 1
               do 40 l = itdel, k - 1
                  i = it + l - 1
                  t(i,j) = t(i+1,j)
   40          continue
   60       continue

            do 80 i = nactiv - itdel + 1, nactiv - 1
               kactiv(i) = kactiv(i+1)
   80       continue
            nactiv = nactiv - 1
         end if
c
         nz = nz + 1
c
         if (nactiv.eq.0) then
            dtmax = one
            dtmin = one
         else

c           restore the nactiv x (nactiv+1) upper-hessenberg matrix  t
c           to upper-triangular form.  the  nsup  super-diagonal
c           elements are removed by a backward sweep of rotations.
c           the rotation for the  (1,1)-th  element of  t  is generated
c           separately.

            nsup = itdel - 1
c
            if (nsup.gt.0) then
               npiv = jt + itdel - 1
               if (nsup.gt.1) then
                  call dcopy(nsup-1,t(it+1,jt+1),ldt+1,s(jt+1),1)
                  call f06qrf('right',nactiv,1,nsup,c(jt+1),s(jt+1),
     *                        t(it,jt+1),ldt)
               end if
c
               call f06baf(t(it,jt+1),t(it,jt),cs,sn)
               t(it,jt) = zero
               s(jt) = -sn
               c(jt) = cs
               call f06qxf('right','variable','backwards',nfree,nfree,
     *                     nz,npiv,c,s,q,ldq)
               call f06qxf('left ','variable','backwards',npiv,ngq,nz,
     *                     npiv,c,s,gqm,n)
            end if
c
            jt = jt + 1
            call f06flf(nactiv,t(it,jt),ldt+1,dtmax,dtmin)
         end if
      end if

      nrz1 = nrz + 1

      if (nz.gt.nrz) then
         if (jdel.gt.0) then
            jart = nrz1 - 1 + idamax(nz-nrz1+1,gqm(nrz1,1),1)
         else
            jart = -jdel
         end if

         if (jart.gt.nrz1) then

c           swap columns  nrz1  and  jart  of  q  and  gqm.

            if (unitq) then
               k = kx(nrz1)
               kx(nrz1) = kx(jart)
               kx(jart) = k
            else
               call dswap(nfree,q(1,nrz1),1,q(1,jart),1)
            end if
c
            call dswap(ngq,gqm(nrz1,1),n,gqm(jart,1),n)
         end if
      end if
c
      nrz = nrz1

      end


      subroutine e04mfl(n,nrz,nz,zerolm,notopt,numinf,trusml,
     *                  smllst,jsmlst,tinyst,jtiny,gq)

c     e04mfl  updates jsmlst and smllst when there are artificial
c     constraints.
c
c     on input,  jsmlst  is the index of the minimum of the set of
c     adjusted multipliers.
c     on output, a negative jsmlst defines the index in q'g of the
c     artificial constraint to be deleted.

      double precision  smllst, tinyst, trusml, zerolm
      integer           jsmlst, jtiny, n, notopt, nrz, numinf,
     *                  nz

      double precision  gq(n),rlam
      integer           j

      do 20 j = nrz + 1, nz
         rlam = -abs(gq(j))
c
         if (rlam.lt.zerolm) then
            if (numinf.eq.0) notopt = notopt + 1
c
            if (rlam.lt.smllst) then
               trusml = gq(j)
               smllst = rlam
               jsmlst = -j
            end if
c
         else if (rlam.lt.tinyst) then
            tinyst = rlam
            jtiny = -j
         end if
   20 continue

      end

      subroutine e04mfm(n,lda,ldt,nactiv,nfree,nz,istate,
     *                  kactiv,kx,zerolm,notopt,numinf,trusml,smllst,
     *                  jsmlst,ksmlst,tinyst,jtiny,jinf,trubig,biggst,
     *                  jbigst,kbigst,a,anorms,gq,rlamda,t,wtinf)

c     e04mfm  first computes the lagrange multiplier estimates for the
c     given working set.  it then determines the values and indices of
c     certain significant multipliers.  in this process, the multipliers
c     for inequalities at their upper bounds are adjusted so that a
c     negative multiplier for an inequality constraint indicates non-
c     optimality.  all adjusted multipliers are scaled by the 2-norm
c     of the associated constraint row.  in the following, the term
c     minimum refers to the ordering of numbers on the real line,  and
c     not to their magnitude.
c
c     jsmlst          is the index of the constraint whose multiplier is
c                     the minimum of the set of adjusted multipliers
c                     with values less than  small.
c     rlamda(ksmlst)  is the associated multiplier.
c
c     jbigst          is the index of the constraint whose multiplier is
c                     the largest of the set of adjusted multipliers
c                     with values greater than (1 + small).
c     rlamda(kbigst)  is the associated multiplier.
c
c     on exit,  elements  1  thru  nactiv  of  rlamda  contain the
c     unadjusted multipliers for the general constraints.  elements
c     nactiv  onwards of  rlamda  contain the unadjusted multipliers
c     for the bounds.

      double precision  one
      parameter         (one=1.0d+0)
      double precision  biggst, smllst, tinyst, trubig, trusml, zerolm
      integer           jbigst, jinf, jsmlst, jtiny, kbigst, ksmlst,
     *                  lda, ldt, n, nactiv, nfree, notopt,
     *                  numinf, nz
      double precision  a(lda,*), anorms(*), gq(n), rlamda(n), t(ldt,*),
     *                  wtinf(*)
      integer           istate(*), kactiv(n), kx(n)
      double precision  anormj, blam, rlam, scdlam
      integer           i, is, j, k, l, nfixed

      nfixed = n - nfree
      jtiny = 0
      jsmlst = 0
      ksmlst = 0
      jbigst = 0
      kbigst = 0

c     ------------------------------------------------------------------
c     compute  jsmlst  for regular constraints and temporary bounds.
c     ------------------------------------------------------------------
c     first, compute the lagrange multipliers for the general
c     constraints in the working set, by solving  t'*lamda = y'g.
c
      if (n.gt.nz) call dcopy(n-nz,gq(nz+1),1,rlamda,1)
      if (nactiv.gt.0) call dtrsv('u','t','n',nactiv,t(1,nz+1),ldt,
     *                            rlamda,1)
c
c     -----------------------------------------------------------------
c     now set elements  nactiv, nactiv+1,... of  rlamda  equal to
c     the multipliers for the bound constraints.
c     -----------------------------------------------------------------
      do 40 l = 1, nfixed
         j = kx(nfree+l)
         blam = rlamda(nactiv+l)
         do 20 k = 1, nactiv
            i = kactiv(k)
            blam = blam - a(i,j)*rlamda(nactiv-k+1)
   20    continue
         rlamda(nactiv+l) = blam
   40 continue
c
c     -----------------------------------------------------------------
c     find  jsmlst  and  ksmlst.
c     -----------------------------------------------------------------
      do 60 k = 1, n - nz
         if (k.gt.nactiv) then
            j = kx(nz+k)
         else
            j = kactiv(nactiv-k+1) + n
         end if
c
         is = istate(j)
c
         i = j - n
         if (j.le.n) anormj = one
         if (j.gt.n) anormj = anorms(i)
c
         rlam = rlamda(k)
c
c        change the sign of the estimate if the constraint is in
c        the working set at its upper bound.
c
         if (is.eq.2) rlam = -rlam
         if (is.eq.3) rlam = abs(rlam)
         if (is.eq.4) rlam = -abs(rlam)
c
         if (is.ne.3) then
            scdlam = rlam*anormj
c
            if (scdlam.lt.zerolm) then
               if (numinf.eq.0) notopt = notopt + 1
c
               if (scdlam.lt.smllst) then
                  smllst = scdlam
                  trusml = rlamda(k)
                  jsmlst = j
                  ksmlst = k
               end if
            else if (scdlam.lt.tinyst) then
               tinyst = scdlam
               jtiny = j
            end if
         end if
c
         scdlam = rlam/wtinf(j)
         if (scdlam.gt.biggst .and. j.gt.jinf) then
            biggst = scdlam
            trubig = rlamda(k)
            jbigst = j
            kbigst = k
         end if
   60 continue

      end

      subroutine e04mfh(n,nclin,lda,istate,numinf,suminf,bl,a,
     *                  featol,cvec,x,wtinf)

c     e04mfh  finds the number and weighted sum of infeasibilities for
c     the bounds and linear constraints.   an appropriate gradient
c     is returned in cvec.
c
c     positive values of  istate(j)  will not be altered.  these mean
c     the following...
c
c               1             2           3
c           a'x = bl      a'x = bu     bl = bu
c
c     other values of  istate(j)  will be reset as follows...
c           a'x lt bl     a'x gt bu     a'x free
c              - 2           - 1           0
c
c     original version written 31-october-1984.
c     this version of e04mfh dated  1-january-1987.
c     ******************************************************************
c
c     .. parameters ..
      double precision  zero
      parameter         (zero=0.0d+0)
c     .. scalar arguments ..
      double precision  suminf
      integer           lda, n, nclin, numinf
c     .. array arguments ..
      double precision  a(lda,*), bl(*), cvec(n), featol(*),
     *                  wtinf(*), x(n)
      integer           istate(*)
c     .. local scalars ..
      double precision  ctx, feasj, s, weight
      integer           j, k
c     .. external functions ..
      double precision  ddot
c
      numinf = 0
      suminf = zero
      call f06fbf(n,(zero),cvec,1)
c
      do 40 j = 1, n + nclin

         if (istate(j).le.0) then
            feasj = featol(j)
            if (j.le.n) then
               ctx = x(j)
            else
               k = j - n
               ctx = ddot(n,a(k,1),lda,x,1)
            end if
            istate(j) = 0
c
c           see if the lower bound is violated.
            if (j.le.n) then      
               s = 0d0 - ctx
               if (s.gt.feasj) then
                  istate(j) = -2
                  weight = -wtinf(j)
                  go to 20
               end if
c           see if the upper bound is violated.

               s = ctx - 1d0
               if (s.le.feasj) go to 40
               istate(j) = -1
               weight = wtinf(j)
            else
               s = bl(j-n) - ctx
               if (s.gt.feasj) then
                  istate(j) = -2
                  weight = -wtinf(j)
                  go to 20
               end if

               if (-s.le.feasj) go to 40
               istate(j) = -1
               weight = wtinf(j)

            end if 
c
c           add the infeasibility.
c
   20       numinf = numinf + 1
            suminf = suminf + abs(weight)*s
            if (j.le.n) then
               cvec(j) = weight
            else
               call daxpy(n,weight,a(k,1),lda,cvec,1)
            end if
         end if
   40 continue

      end

      subroutine f06baf( a, b, c, s )

      double precision   a, b, c, s

c  nag  fortran 77  version of the  srotg blas,  except that c is always
c  returned as non-negative and  b  is overwritten by the tangent of the
c  angle that defines the plane rotation.
c
c  c and s are given as
c
c     c = 1.0/sqrt( 1.0 + t**2 ),   s = c*t   where   t = b/a.
c
c  when  abs( b ) .le. eps*abs( a ),  where  eps is 1.11022302462516d-16,  
c  then  c and s  are always
c  returned as
c
c     c = 1.0  and  s = 0.0
c
c  and when  abs( a ) .le. eps*abs( b ) then c and s are always returned
c  as
c
c     c = 0.0  and  s = sign( t ).
c
c  note that t is always returned as  b/a, unless this would overflow in
c  which  case the value  sign( t )*flmax  is returned,  where  flmax is
c  the value given by  1/2.22507385850721d-308.
c
c  c and s  can be reconstructed from the tangent,  t,  by a call to the
c  nag basic linear algebra routine f06bcf.

      double precision   one         , zero
      parameter        ( one = 1.0d+0, zero = 1d-99)
c     .. local scalars ..
      double precision   t
      logical            fail
c     .. external functions ..
      double precision   f06blf

      if( b.eq.zero )then
         c  = one
         s  = zero
      else
         t  = f06blf( b, a, fail )
         call f06bcf( t, c, s )
         a  = c*a + s*b
         b  = t
      end if

      end

      subroutine f06fqf( pivot, direct, n, alpha, x, incx, c, s )

      double precision   alpha
      integer            incx, n
      character*1        direct, pivot
c     .. array arguments ..
      double precision   c( * ), s( * ), x( * )
c     ..
c
c  f06fqf generates the parameters of an orthogonal matrix p such that
c
c     when   pivot = 'f' or 'f'   and   direct = 'f' or 'f'
c     or     pivot = 'v' or 'v'   and   direct = 'b' or 'b'
c
c        p*( alpha ) = ( beta ),
c          (   x   )   (   0  )
c
c     when   pivot = 'f' or 'f'   and   direct = 'b' or 'b'
c     or     pivot = 'v' or 'v'   and   direct = 'f' or 'f'
c
c        p*(   x   ) = (   0  ),
c          ( alpha ) = ( beta )
c
c  where alpha is a scalar and x is an n element vector.
c
c  when  pivot = 'f' or 'f'  ( fixed pivot )
c  and  direct = 'f' or 'f'  ( forward sequence ) then
c
c     p is given as the sequence of plane rotation matrices
c
c        p = p( n )*p( n - 1 )*...*p( 1 )
c
c     where p( k ) is a plane rotation matrix for the ( 1, k + 1 ) plane
c     designed to annihilate the kth element of x.
c
c  when  pivot = 'v' or 'v'  ( variable pivot )
c  and  direct = 'b' or 'b'  ( backward sequence ) then
c
c     p is given as the sequence of plane rotation matrices
c
c        p = p( 1 )*p( 2 )*...*p( n )
c
c     where p( k ) is a plane rotation matrix for the ( k, k + 1 ) plane
c     designed to annihilate the kth element of x.
c
c  when  pivot = 'f' or 'f'  ( fixed pivot )
c  and  direct = 'b' or 'b'  ( backward sequence ) then
c
c     p is given as the sequence of plane rotation matrices
c
c        p = p( 1 )*p( 2 )*...*p( n )
c
c     where p( k ) is a plane rotation matrix for the ( k, n + 1 ) plane
c     designed to annihilate the kth element of x.
c
c  when  pivot = 'v' or 'v'  ( variable pivot )
c  and  direct = 'f' or 'f'  ( forward sequence ) then
c
c     p is given as the sequence of plane rotation matrices
c
c        p = p( n )*p( n - 1 )*...*p( 1 )
c
c     where p( k ) is a plane rotation matrix for the ( k, k + 1 ) plane
c     designed to annihilate the kth element of x.
c
c  the routine returns the cosine, c( k ), and sine, s( k ) that define
c  the matrix p( k ), such that the two by two rotation part of p( k ),
c  r( k ), has the form
c
c     r( k ) = (  c( k )  s( k ) ).
c              ( -s( k )  c( k ) )
c
c  on entry, alpha must contain  the scalar alpha and on exit, alpha is
c  overwritten by beta. the cosines and sines are returned in the arrays
c  c and s and the vector x is overwritten by the tangents of the plane
c  rotations ( t( k ) = s( k )/c( k ) ).

      integer            i, ix

      if( n.gt.0 )then
         if( ( direct.eq.'b' ).or.( direct.eq.'b' ) )then
            ix = 1 + ( n - 1 )*incx
            if( ( pivot.eq.'v' ).or.( pivot.eq.'v' ) )then
               do 10, i = n, 2, -1
                  call f06baf( x( ix - incx ), x( ix ), c( i ), s( i ) )
                  ix = ix - incx
   10          continue
               call f06baf( alpha, x( ix ), c( 1 ), s( 1 ) )
            else if( ( pivot.eq.'f' ).or.( pivot.eq.'f' ) )then
c
c              here we choose c and s so that
c
c                 ( alpha ) := (  c  s )*( alpha  )
c                 (   0   )    ( -s  c ) ( x( i ) )
c
c              which is equivalent to
c
c                 (   0   ) := ( c  -s )*( x( i ) )
c                 ( alpha )    ( s   c ) ( alpha  )
c
c              and so we need to return  s( i ) = -s  in order to make
c              r( i ) look like
c
c                 r( i ) = (  c( i )  s( i ) ).
c                          ( -s( i )  c( i ) )
c
               do 20, i = n, 1, -1
                  call f06baf( alpha, x( ix ), c( i ), s( i ) )
                  s( i )  = -s( i )
                  x( ix ) = -x( ix )
                  ix      =  ix      - incx
   20          continue
            end if
         else if( ( direct.eq.'f' ).or.( direct.eq.'f' ) )then
            ix = 1
            if( ( pivot.eq.'v' ).or.( pivot.eq.'v' ) )then
c
c              here we choose c and s so that
c
c                 ( x( i + 1 ) ) := (  c  s )*( x( i + 1 ) )
c                 (    0       )    ( -s  c ) ( x( i )     )
c
c              which is equivalent to
c
c                 (    0       ) := ( c  -s )*( x( i )     )
c                 ( x( i + 1 ) )    ( s   c ) ( x( i + 1 ) )
c
c              and so we need to return  s( i ) = -s  in order to make
c              r( i ) look like
c
c                 r( i ) = (  c( i )  s( i ) ).
c                          ( -s( i )  c( i ) )
c
               do 30, i = 1, n - 1
                  call f06baf( x( ix + incx ), x( ix ), c( i ), s( i ) )
                  s( i )  = -s( i )
                  x( ix ) = -x( ix )
                  ix      =  ix      + incx
   30          continue
               call f06baf( alpha, x( ix ), c( n ), s( n ) )
               s( n )  = -s( n )
               x( ix ) = -x( ix )
            else if( ( pivot.eq.'f' ).or.( pivot.eq.'f' ) )then
               do 40, i = 1, n
                  call f06baf( alpha, x( ix ), c( i ), s( i ) )
                  ix = ix + incx
   40          continue
            end if
         end if
      end if
c
      end

      subroutine f06qrf( side, n, k1, k2, c, s, a, lda )

      integer            k1, k2, lda, n
      character*1        side
      double precision   a( lda, * ), c( * ), s( * )

c  f06qrf restores an upper hessenberg matrix h to upper triangular form
c  by  applying a sequence of  plane rotations  from either the left, or
c  the right.  the matrix  h  is assumed to have  non-zero  sub-diagonal
c  elements  in  positions  h( k + 1, k ),  k = k1, k1 + 1, ..., k2 - 1,
c  only  and  h( k + 1, k )  must  be  supplied  in  s( k ).
c
c  h is restored to the upper triangular matrix r either as
c
c     r = p*h,   when   side = 'l' or 'l'  (  left-hand side )
c
c  where p is an orthogonal matrix of the form
c
c     p = p( k2 - 1 )*...*p( k1 + 1 )*p( k1 ),
c
c  or as
c
c     r = h*p',  when   side = 'r' or 'r'  ( right-hand side )
c
c  where p is an orthogonal matrix of the form
c
c     p = p( k1 )*p( k1 + 1 )*...*p( k2 - 1 ),
c
c  in both cases  p( k )  being a  plane rotation  for the  ( k, k + 1 )
c  plane.  the cosine and sine that define p( k ) are returned in c( k )
c  and  s( k )  respectively.  the two by two  rotation part of  p( k ),
c  q( k ), is of the form
c
c     q( k ) = (  c( k )  s( k ) ).
c              ( -s( k )  c( k ) )
c
c  the upper triangular part of the matrix  h  must be supplied in the n
c  by n  leading upper triangular part of  a, and this is overwritten by
c  the upper triangular matrix r.
c
c  if n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
c  greater than n then an immediate return is effected.

      double precision   one, zero
      parameter          ( one = 1.0d+0, zero = 1d-99)
c     .. local scalars ..
      double precision   aij, ctemp, stemp, subh, temp
      integer            i, j

      if( ( min( n, k1 ).lt.1 ).or.( k2.le.k1 ).or.
     $   ( k2.gt.n ) )return
      if( ( side.eq.'l' ).or.( side.eq.'l' ) )then
c
c        restore   h  to  upper  triangular  form  by  annihilating  the
c        sub-diagonal elements of h.  the jth rotation is chosen so that
c
c           ( h( j, j ) ) := (  c  s )*( h( j, j )     ).
c           (     0     )    ( -s  c ) ( h( j + 1, j ) )
c
c        apply the rotations in columns k1 up to n.
c
         do 20 j = k1, n
            aij = a( k1, j )
            do 10 i = k1, min( j, k2 ) - 1
               temp = a( i + 1, j )
               a( i, j ) = s( i )*temp + c( i )*aij
               aij = c( i )*temp - s( i )*aij
   10       continue
            if( j.lt.k2 )then
c
c              set up the rotation.
c
               subh = s( j )
               call f06baf( aij, subh, c( j ), s( j ) )
               a( j, j ) = aij
            else
               a( k2, j ) = aij
            end if
   20    continue
      else if( ( side.eq.'r' ).or.( side.eq.'r' ) )then
c
c        restore   h  to  upper  triangular  form  by  annihilating  the
c        sub-diagonal elements of h.  the jth rotation is chosen so that
c
c           ( h( j + 1, j + 1 ) ) := (  c  s )*( h( j + 1, j + 1 ) ),
c           (         0         )    ( -s  c ) ( h( j + 1, j )     )
c
c        which can be expressed as
c
c           ( 0  h( j + 1, j + 1 ) ) :=
c
c               ( h( j + 1, j )  h( j + 1, j + 1 ) )*(  c  s ).
c                                                    ( -s  c )
c
c        thus we return  c( j ) = c  and  s( j ) = -s  to make the plane
c        rotation matrix look like
c
c           q( j ) = (  c( j )  s( j ) ).
c                    ( -s( j )  c( j ) )
c
         do 40 j = k2 - 1, k1, -1
            subh = s( j )
            call f06baf( a( j + 1, j + 1 ), subh, ctemp, stemp )
            stemp = -stemp
            if (dabs(ctemp).lt.zero) ctemp = 0d0
            s( j ) = stemp
            c( j ) = ctemp
            if( ( ctemp.ne.one ).or.( stemp.ne.zero ) )then
               do 30 i = j, 1, -1
                  temp = a( i, j + 1 )
                  a( i, j + 1 ) = ctemp*temp - stemp*a( i, j )
                  a( i, j ) = stemp*temp + ctemp*a( i, j )
   30          continue
            end if
   40    continue
      end if

      end

      subroutine f06qvf( side, n, k1, k2, c, s, a, lda )

      integer            k1, k2, lda, n
      character*1        side
c     .. array arguments ..
      double precision   a( lda, * ), c( * ), s( * )
c     ..
c
c  f06qvf applies a  given sequence  of  plane rotations  to either  the
c  left,  or the right,  of the  n by n  upper triangular matrix  u,  to
c  transform u to an  upper hessenberg matrix. the rotations are applied
c  in planes k1 up to k2.
c
c  the upper hessenberg matrix, h, is formed as
c
c     h = p*u,    when   side = 'l' or 'l',  (  left-hand side )
c
c  where p is an orthogonal matrix of the form
c
c     p = p( k1 )*p( k1 + 1 )*...*p( k2 - 1 )
c
c  and is formed as
c
c     h = u*p',   when   side = 'r' or 'r',  ( right-hand side )
c
c  where p is an orthogonal matrix of the form
c
c     p = p( k2 - 1 )*...*p( k1 + 1 )*p( k1 ),
c
c  p( k ) being a plane rotation matrix for the  ( k, k + 1 ) plane. the
c  cosine and sine that define p( k ), k = k1, k1 + 1, ..., k2 - 1, must
c  be  supplied  in  c( k )  and  s( k )  respectively.  the  two by two
c  rotation part of p( k ), r( k ), is assumed to have the form
c
c     r( k ) = (  c( k )  s( k ) ).
c              ( -s( k )  c( k ) )
c
c  the matrix  u must be supplied in the n by n leading upper triangular
c  part of the array  a, and this is overwritten by the upper triangular
c  part of  h.
c
c  the  sub-diagonal elements of  h, h( k + 1, k ),  are returned in the
c  elements s( k ),  k = k1, k1 + 1, ..., k2 - 1.
c
c  if n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
c  greater than n then an immediate return is effected.

      double precision   one, zero
      parameter          ( one = 1.0d+0, zero = 1d-99)
c     .. local scalars ..
      double precision   aij, ctemp, stemp, temp
      integer            i, j
c     ..

      if( ( min( n, k1 ).lt.1 ).or.( k2.le.k1 ).or.
     $   ( k2.gt.n ) )return
      if( ( side.eq.'l' ).or.( side.eq.'l' ) )then
c
c        apply the plane rotations to columns n back to k1.
c
         do 20 j = n, k1, -1
            if( j.ge.k2 )then
               aij = a( k2, j )
            else
c
c              form  the  additional sub-diagonal element  h( j + 1, j )
c              and store it in s( j ).
c
               aij = c( j )*a( j, j )
               s( j ) = -s( j )*a( j, j )
            end if
            do 10 i = min( k2, j ) - 1, k1, -1
               temp = a( i, j )
               a( i + 1, j ) = c( i )*aij - s( i )*temp
               aij = s( i )*aij + c( i )*temp
   10       continue
            a( k1, j ) = aij
   20    continue
      else if( ( side.eq.'r' ).or.( side.eq.'r' ) )then
c
c        apply  the  plane rotations  to  columns  k1  up to  ( k2 - 1 )
c        and  form   the   additional  sub-diagonal  elements,   storing
c        h( j + 1, j ) in s( j ).
c
         do 40 j = k1, k2 - 1
            if( ( c( j ).ne.one ).or.( s( j ).ne.zero ) )then
               stemp = s( j )
               ctemp = c( j )
               if (dabs(ctemp).lt.zero) ctemp = 0d0
               do 30 i = 1, j
                  temp = a( i, j + 1 )
                  a( i, j + 1 ) = ctemp*temp - stemp*a( i, j )
                  a( i, j ) = stemp*temp + ctemp*a( i, j )
   30          continue
               s( j ) = stemp*a( j + 1, j + 1 )
               a( j + 1, j + 1 ) = ctemp*a( j + 1, j + 1 )
            end if
   40    continue
      end if

      end

      subroutine f06qxf( side, pivot, direct, m, n, k1, k2, c, s, a,
     $                   lda )

      integer            k1, k2, lda, m, n
      character*1        direct, pivot, side
      double precision   a( lda, * ), c( * ), s( * )

c  f06qxf  performs the transformation

c     a := p*a,   when   side = 'l' or 'l'  (  left-hand side )

c     a := a*p',  when   side = 'r' or 'r'  ( right-hand side )

c  where a is an m by n matrix and p is an orthogonal matrix, consisting
c  of a  sequence  of  plane  rotations,  applied  in  planes  k1 to k2,
c  determined by the parameters pivot and direct as follows:

c     when  pivot  = 'v' or 'v'  ( variable pivot )
c     and   direct = 'f' or 'f'  ( forward sequence ) then
c
c        p is given as a sequence of plane rotation matrices
c
c           p = p( k2 - 1 )*...*p( k1 + 1 )*p( k1 ),
c
c        where  p( k )  is a plane rotation matrix for the  ( k, k + 1 )
c        plane.
c
c     when  pivot  = 'v' or 'v'  ( variable pivot )
c     and   direct = 'b' or 'b'  ( backward sequence ) then
c
c        p is given as a sequence of plane rotation matrices
c
c           p = p( k1 )*p( k1 + 1 )*...*p( k2 - 1 ),
c
c        where  p( k )  is a plane rotation matrix for the  ( k, k + 1 )
c        plane.
c
c     when  pivot  = 't' or 't'  ( top pivot )
c     and   direct = 'f' or 'f'  ( forward sequence ) then
c
c        p is given as a sequence of plane rotation matrices
c
c           p = p( k2 - 1 )*p( k2 - 2 )*...*p( k1 ),
c
c        where  p( k )  is a plane rotation matrix for the ( k1, k + 1 )
c        plane.
c
c     when  pivot  = 't' or 't'  ( top pivot )
c     and   direct = 'b' or 'b'  ( backward sequence ) then
c
c        p is given as a sequence of plane rotation matrices
c
c           p = p( k1 )*p( k1 + 1 )*...*p( k2 - 1 ),
c
c        where  p( k )  is a plane rotation matrix for the ( k1, k + 1 )
c        plane.
c
c     when  pivot  = 'b' or 'b'  ( bottom pivot )
c     and   direct = 'f' or 'f'  ( forward sequence ) then
c
c        p is given as a sequence of plane rotation matrices
c
c           p = p( k2 - 1 )*p( k2 - 2 )*...*p( k1 ),
c
c        where  p( k )  is a  plane rotation  matrix  for the  ( k, k2 )
c        plane.
c
c     when  pivot  = 'b' or 'b'  ( bottom pivot )
c     and   direct = 'b' or 'b'  ( backward sequence ) then
c
c        p is given as a sequence of plane rotation matrices
c
c           p = p( k1 )*p( k1 + 1 )*...*p( k2 - 1 ),
c
c        where  p( k )  is a  plane rotation  matrix  for the  ( k, k2 )
c        plane.
c
c  c( k ) and s( k )  must contain the  cosine and sine  that define the
c  matrix  p( k ).  the  two by two  plane rotation  part of the  matrix
c  p( k ), r( k ), is assumed to be of the form
c
c     r( k ) = (  c( k )  s( k ) ).
c              ( -s( k )  c( k ) )
c
c  if m, n or k1 are less than unity,  or k2 is not greater than k1,  or
c  side = 'l' or 'l'  and  k2  is greater than  m, or  side = 'r' or 'r'
c  and  k2  is greater than  n,  then an  immediate return  is effected.

      double precision   one, zero
      parameter          ( one = 1.0d+0, zero = 1d-99)
c     .. local scalars ..
      double precision   aij, ctemp, stemp, temp
      integer            i, j
      logical            left, right

      left = ( side.eq.'l' ).or.( side.eq.'l' )
      right = ( side.eq.'r' ).or.( side.eq.'r' )
      if( ( min( m, n, k1 ).lt.1 ).or.( k2.le.k1 ).or.
     $    ( ( left ).and.( k2.gt.m ) ).or.
     $    ( ( right ).and.( k2.gt.n ) ) )return
      if( left )then
         if( ( pivot.eq.'v' ).or.( pivot.eq.'v' ) )then
            if( ( direct.eq.'f' ).or.( direct.eq.'f' ) )then
               do 20 j = 1, n
                  aij = a( k1, j )
                  do 10 i = k1, k2 - 1
                     temp = a( i + 1, j )
                     a( i, j ) = s( i )*temp + c( i )*aij
                     aij = c( i )*temp - s( i )*aij
   10             continue
                  a( k2, j ) = aij
   20          continue
            else if( ( direct.eq.'b' ).or.( direct.eq.'b' ) )then
               do 40 j = 1, n
                  aij = a( k2, j )
                  do 30 i = k2 - 1, k1, -1
                     temp = a( i, j )
                     a( i + 1, j ) = c( i )*aij - s( i )*temp
                     aij = s( i )*aij + c( i )*temp
   30             continue
                  a( k1, j ) = aij
   40          continue
            end if
         else if( ( pivot.eq.'t' ).or.( pivot.eq.'t' ) )then
            if( ( direct.eq.'f' ).or.( direct.eq.'f' ) )then
               do 60 j = 1, n
                  temp = a( k1, j )
                  do 50 i = k1, k2 - 1
                     aij = a( i + 1, j )
                     a( i + 1, j ) = c( i )*aij - s( i )*temp
                     temp = s( i )*aij + c( i )*temp
   50             continue
                  a( k1, j ) = temp
   60          continue
            else if( ( direct.eq.'b' ).or.( direct.eq.'b' ) )then
               do 80 j = 1, n
                  temp = a( k1, j )
                  do 70 i = k2 - 1, k1, -1
                     aij = a( i + 1, j )
                     a( i + 1, j ) = c( i )*aij - s( i )*temp
                     temp = s( i )*aij + c( i )*temp
   70             continue
                  a( k1, j ) = temp
   80          continue
            end if
         else if( ( pivot.eq.'b' ).or.( pivot.eq.'b' ) )then
            if( ( direct.eq.'f' ).or.( direct.eq.'f' ) )then
               do 100 j = 1, n
                  temp = a( k2, j )
                  do 90 i = k1, k2 - 1
                     aij = a( i, j )
                     a( i, j ) = s( i )*temp + c( i )*aij
                     temp = c( i )*temp - s( i )*aij
   90             continue
                  a( k2, j ) = temp
  100          continue
            else if( ( direct.eq.'b' ).or.( direct.eq.'b' ) )then
               do 120 j = 1, n
                  temp = a( k2, j )
                  do 110 i = k2 - 1, k1, -1
                     aij = a( i, j )
                     a( i, j ) = s( i )*temp + c( i )*aij
                     temp = c( i )*temp - s( i )*aij
  110             continue
                  a( k2, j ) = temp
  120          continue
            end if
         end if
      else if( right )then
         if( ( pivot.eq.'v' ).or.( pivot.eq.'v' ) )then
            if( ( direct.eq.'f' ).or.( direct.eq.'f' ) )then
               do 140 j = k1, k2 - 1
                  if( ( c( j ).ne.one ).or.( s( j ).ne.zero ) )then
                     ctemp = c( j )
                     if (dabs(ctemp).lt.zero) ctemp = 0d0
                     stemp = s( j )
                     do 130 i = 1, m
                        temp = a( i, j + 1 )
                        a( i, j + 1 ) = ctemp*temp - stemp*a( i, j )
                        a( i, j ) = stemp*temp + ctemp*a( i, j )
  130                continue
                  end if
  140          continue
            else if( ( direct.eq.'b' ).or.( direct.eq.'b' ) )then
               do 160 j = k2 - 1, k1, -1
                  if( ( c( j ).ne.one ).or.( s( j ).ne.zero ) )then
                     ctemp = c( j )
                     if (dabs(ctemp).lt.zero) ctemp = 0d0
                     stemp = s( j )
                     do 150 i = m, 1, -1
                        temp = a( i, j + 1 )
                        a( i, j + 1 ) = ctemp*temp - stemp*a( i, j )
                        a( i, j ) = stemp*temp + ctemp*a( i, j )
  150                continue
                  end if
  160          continue
            end if
         else if( ( pivot.eq.'t' ).or.( pivot.eq.'t' ) )then
            if( ( direct.eq.'f' ).or.( direct.eq.'f' ) )then
               do 180 j = k1 + 1, k2
                  ctemp = c( j - 1 )
                  if (dabs(ctemp).lt.zero) ctemp = 0d0
                  stemp = s( j - 1 )
                  if( ( ctemp.ne.one ).or.( stemp.ne.zero ) )then
                     do 170 i = 1, m
                        temp = a( i, j )
                        a( i, j ) = ctemp*temp - stemp*a( i, k1 )
                        a( i, k1 ) = stemp*temp + ctemp*a( i, k1 )
  170                continue
                  end if
  180          continue
            else if( ( direct.eq.'b' ).or.( direct.eq.'b' ) )then
               do 200 j = k2, k1 + 1, -1
                  ctemp = c( j - 1 )
                  if (dabs(ctemp).lt.zero) ctemp = 0d0
                  stemp = s( j - 1 )
                  if( ( ctemp.ne.one ).or.( stemp.ne.zero ) )then
                     do 190 i = m, 1, -1
                        temp = a( i, j )
                        a( i, j ) = ctemp*temp - stemp*a( i, k1 )
                        a( i, k1 ) = stemp*temp + ctemp*a( i, k1 )
  190                continue
                  end if
  200          continue
            end if
         else if( ( pivot.eq.'b' ).or.( pivot.eq.'b' ) )then
            if( ( direct.eq.'f' ).or.( direct.eq.'f' ) )then
               do 220 j = k1, k2 - 1
                  if( ( c( j ).ne.one ).or.( s( j ).ne.zero ) )then
                     ctemp = c( j )
                     if (dabs(ctemp).lt.zero) ctemp = 0d0
                     stemp = s( j )
                     do 210 i = 1, m
                        temp = a( i, j )
                        a( i, j ) = stemp*a( i, k2 ) + ctemp*temp
                        a( i, k2 ) = ctemp*a( i, k2 ) - stemp*temp
  210                continue
                  end if
  220          continue
            else if( ( direct.eq.'b' ).or.( direct.eq.'b' ) )then
               do 240 j = k2 - 1, k1, -1
                  if( ( c( j ).ne.one ).or.( s( j ).ne.zero ) )then
                     ctemp = c( j )
                     if (dabs(ctemp).lt.zero) ctemp = 0d0
                     stemp = s( j )
                     do 230 i = m, 1, -1
                        temp = a( i, j )
                        a( i, j ) = stemp*a( i, k2 ) + ctemp*temp
                        a( i, k2 ) = ctemp*a( i, k2 ) - stemp*temp
  230                continue
                  end if
  240          continue
            end if
         end if
      end if

      end


      subroutine f06qkf( side, trans, n, perm, k, b, ldb )

      integer            k, ldb, n
      character*1        side, trans

      double precision   perm( * ), b( ldb, * )

c  purpose
c  =======
c
c  f06qkf performs one of the transformations
c
c     b := p'*b   or   b := p*b,   where b is an m by k matrix,
c
c  or
c
c     b := b*p'   or   b := b*p,   where b is a k by m matrix,
c
c  p being an m by m permutation matrix of the form
c
c     p = p( 1, index( 1 ) )*p( 2, index( 2 ) )*...*p( n, index( n ) ),
c
c  where  p( i, index( i ) ) is the permutation matrix that interchanges
c  items i and index( i ). that is p( i, index( i ) ) is the unit matrix
c  with rows and columns  i and  index( i )  interchanged. of course, if
c  index( i ) = i  then  p( i, index( i ) ) = i.
c
c  this  routine is intended  for use in conjunction with  nag auxiliary
c  routines  that  perform  interchange  operations,  such  as  sorting.
c
c  parameters
c  ==========
c
c  side   - character*1.
c  trans
c           on entry,  side  ( left-hand side, or right-hand side )  and
c           trans  ( transpose, or no transpose )  specify the operation
c           to be performed as follows.
c
c           side = 'l' or 'l'   and   trans = 't' or 't'
c
c              perform the operation   b := p'*b.
c
c           side = 'l' or 'l'   and   trans = 'n' or 'n'
c
c              perform the operation   b := p*b.
c
c           side = 'r' or 'r'   and   trans = 't' or 't'
c
c              perform the operation   b := b*p'.
c
c           side = 'r' or 'r'   and   trans = 'n' or 'n'
c
c              perform the operation   b := b*p.
c
c           unchanged on exit.
c
c  n      - integer.
c
c           on entry, n must specify the value of n.  n must be at least
c           zero.  when  n = 0  then an  immediate  return  is effected.
c
c           unchanged on exit.
c
c  perm   - real             array of dimension at least ( n ).
c
c           before  entry,  perm  must  contain  the  n indices  for the
c           permutation matrices. index( i ) must satisfy
c
c              1 .le. index( i ) .le. m.
c
c           it is usual for index( i ) to be at least i, but this is not
c           necessary for this routine. it is assumed that the statement
c           index = perm( i )  returns the correct integer in  index, so
c           that,  if necessary,  perm( i )  should contain a real value
c           slightly larger than  index.
c
c           unchanged on exit.
c
c  k      - integer.
c
c           on entry with  side = 'l' or 'l',  k must specify the number
c           of columns of b and on entry with  side = 'r' or 'r', k must
c           specify the number of rows of  b.  k must be at least  zero.
c           when  k = 0  then an immediate return is effected.
c
c           unchanged on exit.
c
c  b      - real  array  of  dimension ( ldb, ncolb ),  where  ncolb = k
c           when  side = 'l' or 'l'  and  ncolb = m  when  side = 'r' or
c           'r'.
c
c           before entry  with  side = 'l' or 'l',  the  leading  m by k
c           part  of  the  array   b  must  contain  the  matrix  to  be
c           transformed  and before  entry with  side = 'r' or 'r',  the
c           leading  k by m part of the array  b must contain the matrix
c           to  be  transformed.  on exit,   b  is  overwritten  by  the
c           transformed matrix.
c
c  ldb    - integer.
c
c           on entry,  ldb  must specify  the  leading dimension  of the
c           array  b  as declared  in the  calling  (sub) program.  when
c           side = 'l' or 'l'   then  ldb  must  be  at  least  m,  when
c           side = 'r' or 'r'   then  ldb  must  be  at  least  k.
c           unchanged on exit.

      logical            left, null, right, trnsp
      integer            i, j, l
      double precision   temp

      if( min( n, k ).eq.0 ) return
      left = ( side.eq.'l' ).or.( side.eq.'l' )
      right = ( side.eq.'r' ).or.( side.eq.'r' )
      null = ( trans.eq.'n' ).or.( trans.eq.'n' )
      trnsp = ( trans.eq.'t' ).or.( trans.eq.'t' )
      if( left )then
         if( trnsp )then
            do i = 1, n
               l = perm( i )
               if( l.ne.i )then
                  do j = 1, k
                     temp = b( i, j )
                     b( i, j ) = b( l, j )
                     b( l, j ) = temp
                  end do 
               end if
             end do 
         else if( null )then
            do 40 i = n, 1, -1
               l = perm( i )
               if( l.ne.i )then
                  do 30 j = 1, k
                     temp = b( l, j )
                     b( l, j ) = b( i, j )
                     b( i, j ) = temp
   30             continue
               end if
   40       continue
         end if
      else if( right )then
         if( trnsp )then
            do 60 j = n, 1, -1
               l = perm( j )
               if( l.ne.j )then
                  do 50 i = 1, k
                     temp = b( i, j )
                     b( i, j ) = b( i, l )
                     b( i, l ) = temp
   50             continue
               end if
   60       continue
         else if( null )then
            do 80 j = 1, n
               l = perm( j )
               if( l.ne.j )then
                  do 70 i = 1, k
                     temp = b( i, l )
                     b( i, l ) = b( i, j )
                     b( i, j ) = temp
   70             continue
               end if
   80       continue
         end if
      end if

      end

      subroutine f06frf( n, alpha, x, incx, tol, zeta )

      double precision   alpha, tol, zeta
      integer            incx, n
c     .. array arguments ..
      double precision   x( * )

c  f06frf generates details of a generalized householder reflection such
c  that
c
c     p*( alpha ) = ( beta ),   p'*p = i.
c       (   x   )   (   0  )
c
c  p is given in the form
c
c     p = i - ( zeta )*( zeta  z' ),
c             (   z  )
c
c  where z is an n element vector and zeta is a scalar that satisfies
c
c     1.0 .le. zeta .le. sqrt( 2.0 ).
c
c  zeta is returned in zeta unless x is such that
c
c     max( abs( x( i ) ) ) .le. max( eps*abs( alpha ), tol )
c
c  where eps is the relative machine precision and tol is the user
c  supplied value tol, in which case zeta is returned as 0.0 and p can
c  be taken to be the unit matrix.
c
c  beta is overwritten on alpha and z is overwritten on x.
c  the routine may be called with  n = 0  and advantage is taken of the
c  case where  n = 1.

      double precision   one         , zero
      parameter        ( one = 1.0d+0, zero = 1d-99)
c     .. local scalars ..
      double precision   beta, eps, scale, ssq
      logical            first
c     .. save statement ..
      save               eps, first
c     .. data statements ..
      data               first/ .true. /

      if( n.lt.1 )then
         zeta = zero
      else if( ( n.eq.1 ).and.( x( 1 ).eq.zero ) )then
         zeta = zero
      else
c
         if( first )then
            first = .false.
            eps   =  1.11022302462516d-16
         end if
c
c        treat case where p is a 2 by 2 matrix specially.
c
         if( n.eq.1 )then
c
c           deal with cases where  alpha = zero  and
c           abs( x( 1 ) ) .le. max( eps*abs( alpha ), tol )  first.
c
            if( alpha.eq.zero )then
               zeta   =  one
               alpha  =  abs ( x( 1 ) )
               x( 1 ) = -sign( one, x( 1 ) )
            else if( abs( x( 1 ) ).le.max( eps*abs( alpha ), tol ) )then
               zeta   =  zero
            else
               if( abs( alpha ).ge.abs( x( 1 ) ) )then
                  beta = abs( alpha ) *sqrt( 1 + ( x( 1 )/alpha )**2 )
               else
                  beta = abs( x( 1 ) )*sqrt( 1 + ( alpha/x( 1 ) )**2 )
               end if
               zeta = sqrt( ( abs( alpha ) + beta )/beta )
               if( alpha.ge.zero )
     $            beta = -beta
               x( 1 ) = -x( 1 )/( zeta*beta )
               alpha  = beta
            end if
         else
c
c           now p is larger than 2 by 2.
c
            ssq   = one
            scale = zero
            call f06fjf( n, x, incx, scale, ssq )
c
c           treat cases where  scale = zero,
c           scale .le. max( eps*abs( alpha ), tol )  and
c           alpha = zero  specially.
c           note that  scale = max( abs( x( i ) ) ).
c
            if( ( scale.eq.zero ).or.
     $          ( scale.le.max( eps*abs( alpha ), tol ) ) )then
               zeta  = zero
            else if( alpha.eq.zero )then
               zeta  = one
               alpha = scale*sqrt( ssq )
               call dscal( n, -1/alpha, x, incx )
            else
               if( scale.lt.abs( alpha ) )then
                  beta = abs( alpha )*sqrt( 1 + ssq*( scale/alpha )**2 )
               else
                  beta = scale       *sqrt( ssq +   ( alpha/scale )**2 )
               end if
               zeta = sqrt( ( beta + abs( alpha ) )/beta )
               if( alpha.gt.zero )
     $            beta = -beta
               call dscal( n, -1/( zeta*beta ), x, incx )
               alpha = beta
            end if
         end if
      end if

      end

      subroutine f06bcf( t, c, s )

      double precision   c, s, t

c  f06bcf returns values c and s such that

c     c = cos( theta ),   s = sin( theta )

c  for a given value of

c     t = tan( theta ).

c  c is always non-negative and s has the same sign as t, so that

c     c = 1.0/sqrt( 1.0 + t**2 ),   s = t/sqrt( 1.0 + t**2 ).

c  nag fortran 77 o( 1 ) basic linear algebra routine.
c
c  -- written on 28-february-1986.
c     sven hammarling, nag central office.
c  -- modified 19-august-1987.
c     sven hammarling and jeremy du croz, nag central office.
c        no longer sets s to zero when t is less than eps.

c     .. parameters ..
      double precision   one
      parameter        ( one = 1.0d+0 )
c     .. local scalars ..
      double precision   abst, eps, reps, rrteps, rteps
      logical            first
c     .. save statement ..
      save               first, eps, reps, rteps, rrteps
c     .. data statements ..
      data               first/ .true. /

      if( first )then
         first  = .false.
         eps    =  1.11022302462516d-16
         reps   =  1/eps
         rteps  =  sqrt( eps )
         rrteps =  1/rteps
      end if
c
      abst = abs( t )
      if( abst.lt.rteps )then
         c = one
         s = t
      else if( abst.gt.rrteps )then
         c = 1/abst
         s = sign( one, t )
      else
         c = 1/sqrt( 1 + abst**2 )
         s = c*t
      end if
c
      end


      subroutine f06dff( n, x, incx, y, incy )
c     mark 12 release. nag copyright 1986.
c     .. scalar arguments ..
      integer            incx, incy, n
c     .. array arguments ..
      integer            x( * ), y( * )

c  f06dff performs the operation

c     y := x

c  nag fortran 77 o( n ) basic linear algebra routine.

c  -- written on 10-february-1986.
c     sven hammarling, nag central office.

c     .. local scalars ..
      integer            i, ix, iy

      if( n.gt.0 )then
         if( ( incx.eq.incy ).and.( incy.gt.0 ) )then
            do 10, iy = 1, 1 + ( n - 1 )*incy, incy
               y( iy ) = x( iy )
   10       continue
         else
            if( incx.ge.0 )then
               ix = 1
            else
               ix = 1 - ( n - 1 )*incx
            end if
            if( incy.gt.0 )then
               do 20, iy = 1, 1 + ( n - 1 )*incy, incy
                  y( iy ) = x( ix )
                  ix      = ix      + incx
   20          continue
            else
               iy = 1 - ( n - 1 )*incy
               do 30, i = 1, n
                  y( iy ) = x( ix )
                  iy      = iy      + incy
                  ix      = ix      + incx
   30          continue
            end if
         end if
      end if

      end

      subroutine f06flf( n, x, incx, xmax, xmin )
c     mark 12 release. nag copyright 1986.
c     .. scalar arguments ..
      double precision   xmax, xmin
      integer            incx, n
c     .. array arguments ..
      double precision   x( * )
c     ..
c
c  f06flf returns the values xmax and xmin given by
c
c     xmax = max( abs( x( i ) ) ),   xmin = min( abs( x( i ) ) ).
c             i                              i
c
c  if n is less than unity then xmax and xmin are returned as zero.
c
c  nag fortran 77 o( n ) basic linear algebra routine.
c
c  -- written on 27-february-1986.
c     sven hammarling, nag central office.
c
c     .. parameters ..
      double precision   zero
      parameter        ( zero = 1d-99)
c     .. local scalars ..
      integer            ix

      if( n.lt.1 )then
         xmax = zero
         xmin = zero
      else
         xmax = abs( x( 1 ) )
         xmin = xmax
         do 10 ix = 1 + incx, 1 + ( n - 1 )*incx, incx
            xmax = max( xmax, abs( x( ix ) ) )
            xmin = min( xmin, abs( x( ix ) ) )
   10    continue
      end if
c
      end

      subroutine f06fbf( n, const, x, incx )

c     .. scalar arguments ..
      double precision   const
      integer            incx, n
c     .. array arguments ..
      double precision   x( * )

c  f06fbf performs the operation
c
c     x = const*e,   e' = ( 1  1 ... 1 ).
c
c
c  nag fortran 77 o( n ) basic linear algebra routine.
c
c  -- written on 22-september-1983.
c     sven hammarling, nag central office.

c     .. parameters ..
      double precision   zero
      parameter        ( zero = 1d-99)
c     .. local scalars ..
      integer            ix

      if( n.gt.0 )then
         if( const.ne.zero )then
            do 10, ix = 1, 1 + ( n - 1 )*incx, incx
               x( ix ) = const
   10       continue
         else
            do 20, ix = 1, 1 + ( n - 1 )*incx, incx
               x( ix ) = zero
   20       continue
         end if
      end if

      end

      subroutine f06fjf( n, x, incx, scale, sumsq )
      double precision   scale, sumsq
      integer            incx, n
      double precision   x( * )
c     ..
c
c  f06fjf returns the values scl and smsq such that
c
c     ( scl**2 )*smsq = x( 1 )**2 +...+ x( n )**2 + ( scale**2 )*sumsq,
c
c  where x( i ) = x( 1 + ( i - 1 )*incx ). the value of sumsq is assumed
c  to be at least unity and the value of smsq will then satisfy
c
c     1.0 .le. smsq .le. ( sumsq + n ) .
c
c  scale is assumed to be non-negative and scl returns the value
c
c     scl = max( scale, abs( x( i ) ) ) .
c
c  scale and sumsq must be supplied in scale and sumsq respectively.
c  scl and smsq are overwritten on scale and sumsq respectively.
c
c  the routine makes only one pass through the vector x.
c
c
c  nag fortran 77 o( n ) basic linear algebra routine.
c
c  -- written on 22-october-1982.
c     sven hammarling, nag central office.
c
c
c     .. parameters ..
      double precision   zero
      parameter        ( zero = 1d-99)
c     .. local scalars ..
      double precision   absxi
      integer            ix

      if( n.gt.0 )then
         do 10, ix = 1, 1 + ( n - 1 )*incx, incx
            if( x( ix ).ne.zero )then
               absxi = abs( x( ix ) )
               if( scale.lt.absxi )then
                  sumsq = 1     + sumsq*( scale/absxi )**2
                  scale = absxi
               else
                  sumsq = sumsq +       ( absxi/scale )**2
               end if
            end if
   10    continue
      end if

      end




      double precision function f06blf( a, b, fail )
c     mark 12 release. nag copyright 1986.
c     .. scalar arguments ..
      double precision                  a, b
      logical                           fail
c     ..
c
c  f06blf returns the value div given by
c
c     div = ( a/b                 if a/b does not overflow,
c           (
c           ( 0.0                 if a .eq. 0.0,
c           (
c           ( sign( a/b )*flmax   if a .ne. 0.0  and a/b would overflow,
c
c  where  flmax  is a large value, via the function name. in addition if
c  a/b would overflow then  fail is returned as true, otherwise  fail is
c  returned as false.
c
c  note that when  a and b  are both zero, fail is returned as true, but
c  div  is returned as  0.0. in all other cases of overflow  div is such
c  that  abs( div ) = flmax.
c
c  when  b = 0  then  sign( a/b )  is taken as  sign( a ).
c
c  nag fortran 77 o( 1 ) basic linear algebra routine.
c
c  -- written on 26-october-1982.
c     sven hammarling, nag central office.
c
c
c     .. parameters ..
      double precision      one         , zero
      parameter           ( one = 1.0d+0, zero = 1d-99)
c     .. local scalars ..
      double precision      absb, div, flmax, flmin
      logical               first
c     .. save statement ..
      save                  first, flmin, flmax
c     .. data statements ..
      data                  first/ .true. /

      if( a.eq.zero )then
         div = zero
         if( b.eq.zero )then
            fail = .true.
         else
            fail = .false.
         end if
      else
c
         if( first )then
            first = .false.
            flmin =  2.22507385850721d-308
            flmax =  1/flmin
         end if
c
         if( b.eq.zero )then
            div  =  sign( flmax, a )
            fail = .true.
         else
            absb = abs( b )
            if( absb.ge.one )then
               fail = .false.
               if( abs( a ).ge.absb*flmin )then
                  div = a/b
               else
                  div = zero
               end if
            else
               if( abs( a ).le.absb*flmax )then
                  fail = .false.
                  div  =  a/b
               else
                  fail = .true.
                  div  = flmax
                  if( ( ( a.lt.zero ).and.( b.gt.zero ) ).or.
     $                ( ( a.gt.zero ).and.( b.lt.zero ) )     )
     $               div = -div
               end if
            end if
         end if
      end if
c
      f06blf = div

      end


      subroutine f06qhf( matrix, m, n, const, diag, a, lda )
c     mark 13 release. nag copyright 1988.
      character*1        matrix
      double precision   const, diag
      integer            lda, m, n
      double precision   a( lda, * )

c  f06qhf forms the m by n matrix a given by
c
c     a( i, j ) = (  diag  i.eq.j,
c                 (
c                 ( const  i.ne.j.
c
c  if   matrix = 'g' or 'g'   then  a  is regarded  as a general matrix,
c  if   matrix = 'u' or 'u'   then  a  is regarded  as upper triangular,
c                             and only  elements  for which  i.le.j  are
c                             referenced,
c  if   matrix = 'l' or 'l'   then  a  is regarded  as lower triangular,
c                             and only  elements  for which  i.ge.j  are
c                             referenced.

      integer            i, j

      if( ( matrix.eq.'g' ).or.( matrix.eq.'g' ) )then
         do 20 j = 1, n
            do 10 i = 1, m
               a( i, j ) = const
   10       continue
   20    continue
         if( const.ne.diag )then
            do 30 i = 1, min( m, n )
               a( i, i ) = diag
   30       continue
         end if
      else if( ( matrix.eq.'u' ).or.( matrix.eq.'u' ) )then
         do 50 j = 1, n
            do 40 i = 1, min( m, j )
               a( i, j ) = const
   40       continue
   50    continue
         if( const.ne.diag )then
            do 60 i = 1, min( m, n )
               a( i, i ) = diag
   60       continue
         end if
      else if( ( matrix.eq.'l' ).or.( matrix.eq.'l' ) )then
         do 80 j = 1, min( m, n )
            do 70 i = j, m
               a( i, j ) = const
   70       continue
   80    continue
         if( const.ne.diag )then
            do 90 i = 1, min( m, n )
               a( i, i ) = diag
   90       continue
         end if
      end if

      end

      double precision function dnrm2 ( n, x, incx )
      integer                           incx, n
      double precision                  x( * )
c
c    sqrt( x'*x )
c
      double precision      one         , zero
      parameter           ( one = 1.0d+0, zero = 1d-99)
      double precision      norm, scale, ssq
      double precision      f06bmf

      if( n.lt.1 )then
         norm  = zero
      else if( n.eq.1 )then
         norm  = abs( x( 1 ) )
      else
         scale = zero
         ssq   = one
         call f06fjf( n, x, incx, scale, ssq )
         norm  = f06bmf( scale, ssq )
      end if
c
      dnrm2 = norm

      end

      subroutine dscal ( n, alpha, x, incx )

      double precision   alpha
      integer            incx, n
      double precision   x( * )

c     x := alpha*x

      double precision   one         , zero
      parameter        ( one = 1.0d+0, zero = 1d-99)
      integer            ix

      if( n.gt.0 )then
         if( alpha.eq.zero )then
            do 10, ix = 1, 1 + ( n - 1 )*incx, incx
               x( ix ) = zero
   10       continue
         else if( alpha.eq.( -one ) )then
            do 20, ix = 1, 1 + ( n - 1 )*incx, incx
               x( ix ) = -x( ix )
   20       continue
         else if( alpha.ne.one )then
            do 30, ix = 1, 1 + ( n - 1 )*incx, incx
               x( ix ) = alpha*x( ix )
   30       continue
         end if
      end if

      end


      double precision function ddot  ( n, x, incx, y, incy )
      integer                           incx, incy, n
      double precision                  x( * ), y( * )

c      x'y


      double precision      zero
      parameter           ( zero = 1d-99)
      double precision      sum
      integer               i, ix, iy

      sum = zero
      if( n.gt.0 )then
         if( ( incx.eq.incy ).and.( incx.gt.0 ) )then
            do 10, ix = 1, 1 + ( n - 1 )*incx, incx
               sum = sum + x( ix )*y( ix )
   10       continue
         else
            if( incy.ge.0 )then
               iy = 1
            else
               iy = 1 - ( n - 1 )*incy
            end if
            if( incx.gt.0 )then
               do 20, ix = 1, 1 + ( n - 1 )*incx, incx
                  sum = sum + x( ix )*y( iy )
                  iy  = iy  + incy
   20          continue
            else
               ix = 1 - ( n - 1 )*incx
               do 30, i = 1, n
                  sum = sum + x( ix )*y( iy )
                  ix  = ix  + incx
                  iy  = iy  + incy
   30          continue
            end if
         end if
      end if

      ddot = sum

      end

      double precision function f06bmf( scale, ssq )
c     mark 12 release. nag copyright 1986.
c     .. scalar arguments ..
      double precision                  scale, ssq
c     ..
c
c  f06bmf returns the value norm given by
c
c     norm = ( scale*sqrt( ssq ), scale*sqrt( ssq ) .lt. flmax
c            (
c            ( flmax,             scale*sqrt( ssq ) .ge. flmax
c
c  via the function name.
c
c
c  nag fortran 77 o( 1 ) basic linear algebra routine.
c
c  -- written on 22-october-1982.
c     sven hammarling, nag central office.
c
      double precision      flmax, flmin, norm, sqt
      logical               first

      save                  first, flmax
      data                  first/ .true. /

      if( first )then
         first = .false.
         flmin =  2.22507385850721d-308
         flmax =  1/flmin
      end if

      sqt = sqrt( ssq )
      if( scale.lt.flmax/sqt )then
         norm = scale*sqt
      else
         norm = flmax
      end if

      f06bmf = norm

      end

      subroutine dgemv ( trans, m, n, alpha, a, lda, x, incx,
     $                   beta, y, incy )

      double precision   alpha, beta
      integer            incx, incy, lda, m, n
      character*1        trans
      double precision   a( lda, * ), x( * ), y( * )

c    performs one of the matrix-vector operations
c
c     y := alpha*a*x + beta*y,   or   y := alpha*a'*x + beta*y,
c
c  where alpha and beta are scalars, x and y are vectors and a is an
c  m by n matrix.
c
c  parameters
c  ==========
c
c  trans  - character*1.
c           on entry, trans specifies the operation to be performed as
c           follows:
c
c              trans = 'n' or 'n'   y := alpha*a*x + beta*y.
c
c              trans = 't' or 't'   y := alpha*a'*x + beta*y.
c
c              trans = 'c' or 'c'   y := alpha*a'*x + beta*y.
c
c           unchanged on exit.
c
c  m      - integer.
c           on entry, m specifies the number of rows of the matrix a.
c           m must be at least zero.
c           unchanged on exit.
c
c  n      - integer.
c           on entry, n specifies the number of columns of the matrix a.
c           n must be at least zero.
c           unchanged on exit.
c
c  alpha  - double precision.
c           on entry, alpha specifies the scalar alpha.
c           unchanged on exit.
c
c  a      - double precision array of dimension ( lda, n ).
c           before entry, the leading m by n part of the array a must
c           contain the matrix of coefficients.
c           unchanged on exit.
c
c  lda    - integer.
c           on entry, lda specifies the first dimension of a as declared
c           in the calling (sub) program. lda must be at least
c           max( 1, m ).
c           unchanged on exit.
c
c  x      - double precision array of dimension at least
c           ( 1 + ( n - 1 )*abs( incx ) ) when trans = 'n' or 'n'
c           and at least
c           ( 1 + ( m - 1 )*abs( incx ) ) otherwise.
c           before entry, the incremented array x must contain the
c           vector x.
c           unchanged on exit.
c
c  incx   - integer.
c           on entry, incx specifies the increment for the elements of
c           x. incx must not be zero.
c           unchanged on exit.
c
c  beta   - double precision.
c           on entry, beta specifies the scalar beta. when beta is
c           supplied as zero then y need not be set on input.
c           unchanged on exit.
c
c  y      - double precision array of dimension at least
c           ( 1 + ( m - 1 )*abs( incy ) ) when trans = 'n' or 'n'
c           and at least
c           ( 1 + ( n - 1 )*abs( incy ) ) otherwise.
c           before entry with beta non-zero, the incremented array y
c           must contain the vector y. on exit, y is overwritten by the
c           updated vector y.
c
c  incy   - integer.
c           on entry, incy specifies the increment for the elements of
c           y. incy must not be zero.
c           unchanged on exit.
c
c
c  level 2 blas routine.
c
c  -- written on 22-october-1986.
c     jack dongarra, argonne national lab.
c     jeremy du croz, nag central office.
c     sven hammarling, nag central office.
c     richard hanson, sandia national labs.
c  -- do-loops unrolled on 20-november-1986.
c     peter mayes, nag central office.

      double precision   one         , zero
      parameter        ( one = 1.0d+0, zero = 1d-99)
c     .. local scalars ..
      double precision   temp, temp1, temp2, temp3, temp4
      integer            i, info, iy, j, jx, kx, ky, lenx, leny, m4, n4

      info = 0
      if     ( .not.(trans.eq.'n' .or. trans.eq.'n').and.
     $         .not.(trans.eq.'t' .or. trans.eq.'t').and.
     $         .not.(trans.eq.'c' .or. trans.eq.'c')      )then
         info = 1
      else if( m.lt.0 )then
         info = 2
      else if( n.lt.0 )then
         info = 3
      else if( lda.lt.max( 1, m ) )then
         info = 6
      else if( incx.eq.0 )then
         info = 8
      else if( incy.eq.0 )then
         info = 11
      end if
      if( info.ne.0 )then
         ifail = info
         return
      end if
c
c     quick return if possible.
c
      if( ( m.eq.0 ).or.( n.eq.0 ).or.
     $    ( ( alpha.eq.zero ).and.( beta.eq.one ) ) )
     $   return
c
c     set  lenx  and  leny, the lengths of the vectors x and y, and set
c     up the start points in  x  and  y.
c
      if( (trans.eq.'n' .or. trans.eq.'n') )then
         lenx = n
         leny = m
      else
         lenx = m
         leny = n
      end if
      if( incx.gt.0 )then
         kx = 1
      else
         kx = 1 - ( lenx - 1 )*incx
      end if
      if( incy.gt.0 )then
         ky = 1
      else
         ky = 1 - ( leny - 1 )*incy
      end if
c
c     start the operations. in this version the inner loops are all
c     equivalent to axpy operations.
c
c     first form  y := beta*y.
c
      if( beta.ne.one )then
         if( incy.eq.1 )then
            if( beta.eq.zero )then
               do 10, i = 1, leny
                  y( i ) = zero
   10          continue
            else
               do 20, i = 1, leny
                  y( i ) = beta*y( i )
   20          continue
            end if
         else
            iy = ky
            if( beta.eq.zero )then
               do 30, i = 1, leny
                  y( iy ) = zero
                  iy      = iy   + incy
   30          continue
            else
               do 40, i = 1, leny
                  y( iy ) = beta*y( iy )
                  iy      = iy           + incy
   40          continue
            end if
         end if
      end if
      if( alpha.eq.zero )
     $   return
      jx = kx
      if( (trans.eq.'n' .or. trans.eq.'n') )then
c
c        form  y := alpha*a*x + y.
c
         if( incy.eq.1 )then
c**** u n r o l l   t o   d e p t h   4 ********************************
            n4 = 4*( n/4 )
            do 60, j = 1, n4, 4
               temp1 = alpha*x( jx )
               temp2 = alpha*x( jx + incx )
               temp3 = alpha*x( jx + 2*incx )
               temp4 = alpha*x( jx + 3*incx )
               if( temp1.ne.zero.or.temp2.ne.zero.or.temp3.ne.zero.or.
     $             temp4.ne.zero )then
                  do 50, i = 1, m
                     y( i ) = ( ( ( ( y( i ) + temp1*a( i, j ) )
     $                        + temp2*a( i, j + 1 ) )
     $                        + temp3*a( i, j + 2 ) )
     $                        + temp4*a( i, j + 3 ) )
   50             continue
               end if
               jx = jx + 4*incx
   60       continue
c**** clean-up loop ****************************************************
            do 80, j = n4 + 1, n, 1
               temp = alpha*x( jx )
               if( temp.ne.zero )then
                  do 70, i = 1, m
                     y( i ) = y( i ) + temp*a( i, j )
   70             continue
               end if
               jx = jx + incx
   80       continue
         else
c**** u n r o l l   t o   d e p t h   4 ********************************
            n4 = 4*( n/4 )
            do 100, j = 1, n4, 4
               temp1 = alpha*x( jx )
               temp2 = alpha*x( jx + incx )
               temp3 = alpha*x( jx + 2*incx )
               temp4 = alpha*x( jx + 3*incx )
               if( temp1.ne.zero.or.temp2.ne.zero.or.temp3.ne.zero.or.
     $             temp4.ne.zero )then
                  iy = ky
                  do 90, i = 1, m
                     y( iy ) = ( ( ( ( y( iy ) + temp1*a( i, j ) )
     $                         + temp2*a( i, j + 1 ) )
     $                         + temp3*a( i, j + 2 ) )
     $                         + temp4*a( i, j + 3 ) )
                     iy = iy + incy
   90             continue
               end if
               jx = jx + 4*incx
  100       continue
c**** clean-up loop ****************************************************
            do 120, j = n4 + 1, n, 1
               if( x( jx ).ne.zero )then
                  temp = alpha*x( jx )
                  iy = ky
                  do 110, i = 1, m
                     y( iy ) = y( iy ) + temp*a( i, j )
                     iy = iy + incy
  110             continue
               end if
               jx = jx + incx
  120       continue
         end if
      else
c
c        form  y := alpha*a'*x + y.
c
         if( incy.eq.1 )then
c**** u n r o l l   t o   d e p t h   4 ********************************
            m4 = 4*( m/4 )
            do 140, j = 1, m4, 4
               temp1 = alpha*x( jx )
               temp2 = alpha*x( jx + incx )
               temp3 = alpha*x( jx + 2*incx )
               temp4 = alpha*x( jx + 3*incx )
               if( temp1.ne.zero.or.temp2.ne.zero.or.temp3.ne.zero.or.
     $             temp4.ne.zero )then
                  do 130, i = 1, n
                     y( i ) = ( ( ( ( y( i ) + temp1*a( j, i ) )
     $                        + temp2*a( j + 1, i ) )
     $                        + temp3*a( j + 2, i ) )
     $                        + temp4*a( j + 3, i ) )
  130             continue
               end if
               jx = jx + 4*incx
  140       continue
c**** clean-up loop ****************************************************
            do 160, j = m4 + 1, m, 1
               temp = alpha*x( jx )
               if( temp.ne.zero )then
                  do 150, i = 1, n
                     y( i ) = y( i ) + temp*a( j, i )
  150             continue
               end if
               jx = jx + incx
  160       continue
         else
c**** u n r o l l   t o   d e p t h   4 ********************************
            m4 = 4*( m/4 )
            do 180, j = 1, m4, 4
               temp1 = alpha*x( jx )
               temp2 = alpha*x( jx + incx )
               temp3 = alpha*x( jx + 2*incx )
               temp4 = alpha*x( jx + 3*incx )
               if( temp1.ne.zero.or.temp2.ne.zero.or.temp3.ne.zero.or.
     $             temp4.ne.zero )then
                  iy = ky
                  do 170, i = 1, n
                     y( iy ) = ( ( ( ( y( iy ) + temp1*a( j, i ) )
     $                         + temp2*a( j + 1, i ) )
     $                         + temp3*a( j + 2, i ) )
     $                         + temp4*a( j + 3, i ) )
                     iy = iy + incy
  170             continue
               end if
               jx = jx + 4*incx
  180       continue
c**** clean-up loop ****************************************************
            do 200, j = m4 + 1, m, 1
               if( x( jx ).ne.zero )then
                  temp = alpha*x( jx )
                  iy = ky
                  do 190, i = 1, n
                     y( iy ) = y( iy ) + temp*a( j, i )
                     iy = iy + incy
  190             continue
               end if
               jx = jx + incx
  200       continue
         end if
      end if

      end


      subroutine dcopy ( n, x, incx, y, incy )

      integer            incx, incy, n
      double precision   x( * ), y( * )

c     y := x

      integer            i, ix, iy

      if( n.gt.0 )then
         if( ( incx.eq.incy ).and.( incy.gt.0 ) )then
            do 10, iy = 1, 1 + ( n - 1 )*incy, incy
               y( iy ) = x( iy )
   10       continue
         else
            if( incx.ge.0 )then
               ix = 1
            else
               ix = 1 - ( n - 1 )*incx
            end if
            if( incy.gt.0 )then
               do 20, iy = 1, 1 + ( n - 1 )*incy, incy
                  y( iy ) = x( ix )
                  ix      = ix      + incx
   20          continue
            else
               iy = 1 - ( n - 1 )*incy
               do 30, i = 1, n
                  y( iy ) = x( ix )
                  iy      = iy      + incy
                  ix      = ix      + incx
   30          continue
            end if
         end if
      end if

      end

      subroutine daxpy ( n, alpha, x, incx, y, incy )
      double precision   alpha
      integer            incx, incy, n
      double precision   x( * ), y( * )

c     y := alpha*x + y

      double precision   zero
      parameter        ( zero = 1d-99)
      integer            i, ix, iy

      if( n.gt.0 )then
         if( alpha.ne.zero )then
            if( ( incx.eq.incy ).and.( incx.gt.0 ) )then
               do 10, ix = 1, 1 + ( n - 1 )*incx, incx
                  y( ix ) = alpha*x( ix ) + y( ix )
   10          continue
            else
               if( incy.ge.0 )then
                  iy = 1
               else
                  iy = 1 - ( n - 1 )*incy
               end if
               if( incx.gt.0 )then
                  do 20, ix = 1, 1 + ( n - 1 )*incx, incx
                     y( iy ) = alpha*x( ix ) + y( iy )
                     iy      = iy            + incy
   20             continue
               else
                  ix = 1 - ( n - 1 )*incx
                  do 30, i = 1, n
                     y( iy ) = alpha*x( ix ) + y( iy )
                     ix      = ix            + incx
                     iy      = iy            + incy
   30             continue
               end if
            end if
         end if
      end if

      end

      subroutine dtrsv ( uplo, trans, diag, n, a, lda, x, incx )

      integer            incx, lda, n
      character*1        diag, trans, uplo
      double precision   a( lda, * ), x( * )

c  dtrsv  solves one of the systems of equations
c
c     a*x = b,   or   a'*x = b,
c
c  where b and x are n element vectors and a is an n by n unit, or
c  non-unit, upper or lower triangular matrix.
c
c  no test for singularity or near-singularity is included in this
c  routine. such tests must be performed before calling this routine.
c
c  parameters
c  ==========
c
c  uplo   - character*1.
c           on entry, uplo specifies whether the matrix is an upper or
c           lower triangular matrix as follows:
c
c              uplo = 'u' or 'u'   a is an upper triangular matrix.
c
c              uplo = 'l' or 'l'   a is a lower triangular matrix.
c
c           unchanged on exit.
c
c  trans  - character*1.
c           on entry, trans specifies the equations to be solved as
c           follows:
c
c              trans = 'n' or 'n'   a*x = b.
c
c              trans = 't' or 't'   a'*x = b.
c
c              trans = 'c' or 'c'   a'*x = b.
c
c           unchanged on exit.
c
c  diag   - character*1.
c           on entry, diag specifies whether or not a is unit
c           triangular as follows:
c
c              diag = 'u' or 'u'   a is assumed to be unit triangular.
c
c              diag = 'n' or 'n'   a is not assumed to be unit
c                                  triangular.
c
c           unchanged on exit.
c
c  n      - integer.
c           on entry, n specifies the order of the matrix a.
c           n must be at least zero.
c           unchanged on exit.
c
c  a      - double precision array of dimension ( lda, n ).
c           before entry with  uplo = 'u' or 'u', the leading n by n
c           upper triangular part of the array a must contain the upper
c           triangular matrix and the strictly lower triangular part of
c           a is not referenced.
c           before entry with uplo = 'l' or 'l', the leading n by n
c           lower triangular part of the array a must contain the lower
c           triangular matrix and the strictly upper triangular part of
c           a is not referenced.
c           note that when  diag = 'u' or 'u', the diagonal elements of
c           a are not referenced either, but are assumed to be unity.
c           unchanged on exit.
c
c  lda    - integer.
c           on entry, lda specifies the first dimension of a as declared
c           in the calling (sub) program. lda must be at least
c           max( 1, n ).
c           unchanged on exit.
c
c  x      - double precision array of dimension at least
c           ( 1 + ( n - 1 )*abs( incx ) ).
c           before entry, the incremented array x must contain the n
c           element right-hand side vector b. on exit, x is overwritten
c           with the solution vector x.
c
c  incx   - integer.
c           on entry, incx specifies the increment for the elements of
c           x. incx must not be zero.
c           unchanged on exit.
c
c
c  level 2 blas routine.
c
c  -- written on 22-october-1986.
c     jack dongarra, argonne national lab.
c     jeremy du croz, nag central office.
c     sven hammarling, nag central office.
c     richard hanson, sandia national labs.

      double precision   zero
      parameter        ( zero = 1d-99)
      double precision   temp
      integer            i, info, ix, j, jx, kx
      logical            nounit

      info = 0
      if     ( .not.(uplo .eq.'u' .or. uplo .eq.'u').and.
     $         .not.(uplo .eq.'l' .or. uplo .eq.'l')      )then
         info = 1
      else if( .not.(trans.eq.'n' .or. trans.eq.'n').and.
     $         .not.(trans.eq.'t' .or. trans.eq.'t').and.
     $         .not.(trans.eq.'c' .or. trans.eq.'c')      )then
         info = 2
      else if( .not.(diag .eq.'u' .or. diag .eq.'u').and.
     $         .not.(diag .eq.'n' .or. diag .eq.'n')      )then
         info = 3
      else if( n.lt.0 )then
         info = 4
      else if( lda.lt.max( 1, n ) )then
         info = 6
      else if( incx.eq.0 )then
         info = 8
      end if
      if( info.ne.0 )then
          ifail  = info
      end if
c
c     quick return if possible.
c
      if( n.eq.0 ) return
c
      nounit = (diag.eq.'n' .or. diag.eq.'n')
c
c     set up the start point in x if the increment is not unity. this
c     will be  ( n - 1 )*incx  too small for descending loops.
c
      if( incx.le.0 )then
         kx = 1 - ( n - 1 )*incx
      else if( incx.ne.1 )then
         kx = 1
      end if
c
c     start the operations. in this version the elements of a are
c     accessed sequentially with one pass through a.
c
      if( (trans.eq.'n' .or. trans.eq.'n') )then

c        form  x := inv( a )*x.

         if( (uplo.eq.'u' .or. uplo.eq.'u') )then
            if( incx.eq.1 )then
               do 20, j = n, 1, -1
                  if( x( j ).ne.zero )then
                     if( nounit )
     $                  x( j ) = x( j )/a( j, j )
                     temp = x( j )
                     do 10, i = j - 1, 1, -1
                        x( i ) = x( i ) - temp*a( i, j )
   10                continue
                  end if
   20          continue
            else
               jx = kx + ( n - 1 )*incx
               do 40, j = n, 1, -1
                  if( x( jx ).ne.zero )then
                     if( nounit )
     $                  x( jx ) = x( jx )/a( j, j )
                     temp = x( jx )
                     ix   = jx
                     do 30, i = j - 1, 1, -1
                        ix      = ix      - incx
                        x( ix ) = x( ix ) - temp*a( i, j )
   30                continue
                  end if
                  jx = jx - incx
   40          continue
            end if
         else
            if( incx.eq.1 )then
               do 60, j = 1, n
                  if( x( j ).ne.zero )then
                     if( nounit )
     $                  x( j ) = x( j )/a( j, j )
                     temp = x( j )
                     do 50, i = j + 1, n
                        x( i ) = x( i ) - temp*a( i, j )
   50                continue
                  end if
   60          continue
            else
               jx = kx
               do 80, j = 1, n
                  if( x( jx ).ne.zero )then
                     if( nounit )
     $                  x( jx ) = x( jx )/a( j, j )
                     temp = x( jx )
                     ix   = jx
                     do 70, i = j + 1, n
                        ix      = ix      + incx
                        x( ix ) = x( ix ) - temp*a( i, j )
   70                continue
                  end if
                  jx = jx + incx
   80          continue
            end if
         end if
      else

c        form  x := inv( a' )*x.

         if( (uplo.eq.'u' .or. uplo.eq.'u') )then
            if( incx.eq.1 )then
               do 100, j = 1, n
                  temp = x( j )
                  do 90, i = 1, j - 1
                     temp = temp - a( i, j )*x( i )
   90             continue
                  if( nounit )
     $               temp = temp/a( j, j )
                  x( j ) = temp
  100          continue
            else
               jx = kx
               do 120, j = 1, n
                  temp = x( jx )
                  ix   = kx
                  do 110, i = 1, j - 1
                     temp = temp - a( i, j )*x( ix )
                     ix   = ix   + incx
  110             continue
                  if( nounit )
     $               temp = temp/a( j, j )
                  x( jx ) = temp
                  jx      = jx   + incx
  120          continue
            end if
         else
            if( incx.eq.1 )then
               do 140, j = n, 1, -1
                  temp = x( j )
                  do 130, i = n, j + 1, -1
                     temp = temp - a( i, j )*x( i )
  130             continue
                  if( nounit )
     $               temp = temp/a( j, j )
                  x( j ) = temp
  140          continue
            else
               kx = kx + ( n - 1 )*incx
               jx = kx
               do 160, j = n, 1, -1
                  temp = x( jx )
                  ix   = kx
                  do 150, i = n, j + 1, -1
                     temp = temp - a( i, j )*x( ix )
                     ix   = ix   - incx
  150             continue
                  if( nounit )
     $               temp = temp/a( j, j )
                  x( jx ) = temp
                  jx      = jx   - incx
  160          continue
            end if
         end if
      end if

      end

      subroutine dger  ( m, n, alpha, x, incx, y, incy, a, lda )

      double precision   alpha
      integer            incx, incy, lda, m, n

      double precision   a( lda, * ), x( * ), y( * )

c  dger   performs the rank 1 operation

c     a := alpha*x*y' + a,

c  where alpha is a scalar, x is an m element vector, y is an n element
c  vector and a is an m by n matrix.

c  parameters
c  ==========
c
c  m      - integer.
c           on entry, m specifies the number of rows of the matrix a.
c           m must be at least zero.
c           unchanged on exit.
c
c  n      - integer.
c           on entry, n specifies the number of columns of the matrix a.
c           n must be at least zero.
c           unchanged on exit.
c
c  alpha  - double precision.
c           on entry, alpha specifies the scalar alpha.
c           unchanged on exit.
c
c  x      - double precision array of dimension at least
c           ( 1 + ( m - 1 )*abs( incx ) ).
c           before entry, the incremented array x must contain the m
c           element vector x.
c           unchanged on exit.
c
c  incx   - integer.
c           on entry, incx specifies the increment for the elements of
c           x. incx must not be zero.
c           unchanged on exit.
c
c  y      - double precision array of dimension at least
c           ( 1 + ( n - 1 )*abs( incy ) ).
c           before entry, the incremented array y must contain the n
c           element vector y.
c           unchanged on exit.
c
c  incy   - integer.
c           on entry, incy specifies the increment for the elements of
c           y. incy must not be zero.
c           unchanged on exit.
c
c  a      - double precision array of dimension ( lda, n ).
c           before entry, the leading m by n part of the array a must
c           contain the matrix of coefficients. on exit, a is
c           overwritten by the updated matrix.
c
c  lda    - integer.
c           on entry, lda specifies the first dimension of a as declared
c           in the calling (sub) program. lda must be at least
c           max( 1, m ).
c           unchanged on exit.
c
c  level 2 blas routine.
c
c  -- written on 22-october-1986.
c     jack dongarra, argonne national lab.
c     jeremy du croz, nag central office.
c     sven hammarling, nag central office.
c     richard hanson, sandia national labs.

      double precision   zero
      parameter        ( zero = 1d-99)
      double precision   temp
      integer            i, info, ix, j, jy, kx

      info = 0
      if     ( m.lt.0 )then
         info = 1
      else if( n.lt.0 )then
         info = 2
      else if( incx.eq.0 )then
         info = 5
      else if( incy.eq.0 )then
         info = 7
      else if( lda.lt.max( 1, m ) )then
         info = 9
      end if
      if( info.ne.0 ) ifail = 0 

c     quick return if possible.

      if( ( m.eq.0 ).or.( n.eq.0 ).or.( alpha.eq.zero ) ) return

c     start the operations. in this version the elements of a are
c     accessed sequentially with one pass through a.

      if( incy.gt.0 )then
         jy = 1
      else
         jy = 1 - ( n - 1 )*incy
      end if
      if( incx.eq.1 )then
         do 20, j = 1, n
            if( y( jy ).ne.zero )then
               temp = alpha*y( jy )
               do 10, i = 1, m
                  a( i, j ) = a( i, j ) + x( i )*temp
   10          continue
            end if
            jy = jy + incy
   20    continue
      else
         if( incx.gt.0 )then
            kx = 1
         else
            kx = 1 - ( m - 1 )*incx
         end if
         do 40, j = 1, n
            if( y( jy ).ne.zero )then
               temp = alpha*y( jy )
               ix   = kx
               do 30, i = 1, m
                  a( i, j ) = a( i, j ) + x( ix )*temp
                  ix        = ix        + incx
   30          continue
            end if
            jy = jy + incy
   40    continue
      end if

      end

      subroutine dswap ( n, x, incx, y, incy )
      integer            incx, incy, n
      double precision   x( * ), y( * )
c
c     temp := x,   x := y,   y := temp.
c
      double precision   temp
      integer            i, ix, iy

      if( n.gt.0 )then
         if( ( incx.eq.incy ).and.( incy.gt.0 ) )then
            do 10, iy = 1, 1 + ( n - 1 )*incy, incy
               temp    = x( iy )
               x( iy ) = y( iy )
               y( iy ) = temp
   10       continue
         else
            if( incx.ge.0 )then
               ix = 1
            else
               ix = 1 - ( n - 1 )*incx
            end if
            if( incy.gt.0 )then
               do 20, iy = 1, 1 + ( n - 1 )*incy, incy
                  temp    = x( ix )
                  x( ix ) = y( iy )
                  y( iy ) = temp
                  ix      = ix      + incx
   20          continue
            else
               iy = 1 - ( n - 1 )*incy
               do 30, i = 1, n
                  temp    = x( ix )
                  x( ix ) = y( iy )
                  y( iy ) = temp
                  iy      = iy      + incy
                  ix      = ix      + incx
   30          continue
            end if
         end if
      end if

      end

      integer function idamax( n, x, incx )

      integer                  incx, n
      double precision         x( * )

c     abs( x( i ) ) = max( abs( x( j ) ) )

      double precision         xmax
      integer                  i, imax, ix

      if( n.gt.0 )then
         imax = 1
         if( n.gt.1 )then
            xmax = abs( x( 1 ) )
            ix   = 1
            do 10, i = 2, n
               ix = ix + incx
               if( xmax.lt.abs( x( ix ) ) )then
                  xmax = abs( x( ix ) )
                  imax = i
               end if
   10       continue
         end if
      else
         imax = 0
      end if

      idamax = imax

      end