      program species

      implicit double precision (a-g,o-y),integer (h-n)

      include 'perplex_parameters.h'

      character specie(nsp)*3, vname*8, yes*1

      integer  igo, ins(nsp), ifug, irk

      double precision 
     *       x(nsp,1000),f(1000),y(1000),ns(1000),no(1000),
     *       nh(1000),nc(1000),ac(1000)


      common / cst11 /fh2o,fco2/ cst5 /p,t,xo,u(6)
     *       / cstcoh /xs(nsp),g(nsp),v(nsp)/ cst26 /vol
     *       / cst10 /iff(2),idss(h5),ifug,ifyn,isyn
     *       / cst24 /ipot,jv(l2),iv(l2)
     *       / cst100 /dlnfo2,elag,gz,gy,gx,ibuf,hu,hv,hw,hx

      data tentoe, fo2, fs2, specie /2.302585093d0, 0.d0, 0d0,
     *      'H2O','CO2','CO ','CH4','H2 ','H2S','O2 ',
     *      'SO2','COS','UNK'/

c-----------------------------------------------------------------------

50    igo = 0
      fs2 = -9999.*tentoe/2.
      elag = 0.
c                                  initialize species fractions/volumes
      do 60 i = 1, nsp
60       xs(i) = 0.
c                                  get the users choice of EoS:   
      call rfluid (irk, ifug, 6)

      write (*,*) ' p, t, xo, xmin,xmax,xonc'
      read (*,*) p, t, xo, xmin,xmax, xonc
      elag = xmax
      open (10,file='species.dat')
      write (10,2030) 0.,' ',' ',' ',' ',xmax,xmin,0,-10.,
     *                '  X(S) ',' log(Y) '


      igo = 0
      fmin = 20.
      fmax = -20.
      k = 0
c                                  for multispecies fluids set
c                                  up species indices:
      if (ifug.gt.6.and.ifug.lt.13.or.ifug.ge.19) then
         vname = '  X(O)  '
         if (ifug.eq.7.or.ifug.eq.8) vname = 'log(fo2)'
         isp = 5
         do 1 i = 1, 6
1           ins(i) = i
         if (ifug.eq.12.or.ifug.ge.19) then
            isp = 8
            ins(7) = 8
            ins(8) = 9
         end if
      else if (ifug.eq.16) then
         vname = '  X(O)  '
         isp = 3
         ins(1) = 1
         ins(2) = 5
         ins(3) = 7
      else if (ifug.eq.17) then
         vname = '  X(O)  '
         isp = 4
         ins(1) = 1
         ins(2) = 5
         ins(3) = 6
         ins(4) = 8
      else if (ifug.eq.13.or.ifug.eq.15) then 
         vname = ' X(H2)  '
      end if 
c                                  call fluid routine:
10    call cfluid (fo2, fs2)

      k = k + 1

      totx = 0.

      do 90 i = 1, isp
         j = ins(i)
         totx = totx + xs(j)
         if (xs(j).gt.1.d0) xs(j) = 1.d0
         if (xs(j).le.0.d0) xs(j) = 1.d-99         
90       x(j,k) = dlog10(xs(j))

      if (totx.gt.1.01.or.totx.lt.0.99) then
         k = k - 1
         elag = elag - xonc
         if (elag.le.xmin) goto 37
         goto 10
      end if

      f(k) = fo2/tentoe
      if (f(k).lt.fmin) fmin = f(k)
      if (f(k).gt.fmax) fmax = f(k)

      ns(k) = xs(6) + xs(8) + xs(9) + xs(10)
      no(k) = xs(1) + xs(2)*2.+ xs(3) + xs(7)*2. 
     *               + xs(8)*2. + xs(9) + xs(10)*3.
      nc(k) = xs(2) + xs(3) + xs(4) + xs(9)
      nh(k) = (xs(1) + xs(5) + xs(6))*2. + xs(4)*4. 
      ac(k) = 10.**(gz)
      if (ifug.eq.12) ac(k) = elag
      if (ac(k).le.0.) ac(k) = 1.d-99

      tot = ns(k) + no(k) + nh(k) + nc(k)     
 
      ns(k) = ns(k) / tot
      no(k) = no(k) / tot
      nc(k) = nc(k) / tot
      nh(k) = nh(k) / tot

      y(k) = ns(k) / (ns(k) + nc(k))

      write (*,2000) elag,(xs(ins(i)),i=1,isp),fo2/tentoe,y(k)
      z1 = nc(k)
      z2 = nh(k)
      z3 = no(k)

       z2 = z2 / 2
       z3 = z3 - 2.*z1 - z2

       tot = z1 + z2 + z3

       z1 = z1 / tot
       z2 = z2 / tot
       z3 = z3 / tot

      write (*,2000) z1, z2, z3 

      if (ns(k).eq.0.) ns(k) = 1.  
      if (no(k).eq.0.) no(k) = 1.  
      if (nh(k).eq.0.) nh(k) = 1.  
      if (nc(k).eq.0.) nc(k) = 1.  

      elag = elag - xonc

37    goto (20), igo

      if (elag.le.xmin) then
         write (*,*) 'do a special point, i=0'
         read (*,*) i
         igo = 1

         if (i.eq.0) then
            call rfluid (irk, ifug, 6)
            elag = 0.
            goto 10
         end if
 
      end if    

      goto 10

20    do 140 i = 1, isp
         j = ins(i)
         write (10,2010) 2*k,j,i+2,1,1,1,1,1,1,0.,specie(j)
140      write (10,2020) (y(l),x(j,l),l=1,k)
c                                            O2 fugacity
         write (10,2010) 2*k,1,1, 1,1,1,1,1,1,0.,'f(O2)'
         write (10,2020) (y(l),f(l),l=1,k)
c                                            bulk fractions:
         write (10,2010) 2*k,2,2,1,1,1,1,1,1,0.,'C' 
         write (10,2020) (y(l), dlog10(nc(l)),l=1,k)
         write (10,2010) 2*k,2,2,1,1,1,1,1,1,0.,'H'
         write (10,2020) (y(l),dlog10(nh(l)),l=1,k)
         write (10,2010) 2*k,2,2,1,1,1,1,1,1,0.,'O'
         write (10,2020) (y(l),dlog10(no(l)),l=1,k)
         write (10,2010) 2*k,2,2,1,1,1,1,1,1,0.,'S'
         write (10,2020) (y(l),dlog10(ns(l)),l=1,k)
         write (10,2010) 2*k,2,20,1,1,1,1,1,1,0.,'a(C)'
         write (10,2020) (y(l),dlog10(ac(l)),l=1,k)

2000  format (8(g12.6,2x))
2010  format (i5,8(i2,1x),f4.1,1x,a8)
2020  format (6(g12.6,1x))
2030  format ('1',/,'0 0 0',/,'0 0 0 0 0 0 ',
     *        /,g9.1,1x,a162,3(/,a162),/,'2 1 2 0 0',/,
     *        4(g12.6,1x),/,a8,/,a8)
1210  format (/,' Change EoS, buffer, or graphite activity (y/n)?',/)
1220  format (a1)

99    write (*,1210) 
      read (*,1220) yes
      if (yes.eq.'y'.or.yes.eq.'Y') goto 50

      end 
 
      block data
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-y)
 
      common/ cst5 /p,t,xco2,u1,u2,tr,pr,r,ps/ cst85 /pp,tt,yy,rr
      data r,rr/8.3144126d0,83.14d0/
      end
